unit SudoSelecteur;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TFrmSelecteur = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheetPose: TTabSheet;
    TabSheetCandidats: TTabSheet;
    C1: TBitBtn;
    C2: TBitBtn;
    BtCancel: TBitBtn;
    C3: TBitBtn;
    C4: TBitBtn;
    C5: TBitBtn;
    C6: TBitBtn;
    C9: TBitBtn;
    C7: TBitBtn;
    C8: TBitBtn;
    P1: TBitBtn;
    P2: TBitBtn;
    P3: TBitBtn;
    P6: TBitBtn;
    P5: TBitBtn;
    P4: TBitBtn;
    P7: TBitBtn;
    P8: TBitBtn;
    P9: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
   Transparence : Integer;

   Procedure Couleur(Couleur : TColor; NumTag : Integer);
   procedure Button_OnOff(listeCandidats : String; NumTag : Integer);

  end;

var
  FrmSelecteur: TFrmSelecteur;

implementation

{$R *.dfm}

// ****************************************************
// redessine les boutons avec la bonne couleur
// ****************************************************
procedure TFrmSelecteur.Couleur(Couleur : TColor; NumTag : Integer);
Var
 I : integer ;
begin
 For i := 0 to ComponentCount-1 do   // pour chaque composant
  If Components[i] is TBitBtn then   // de type TBitBtn
   If (Components[i] as TBitBtn).Tag = NumTag then // avec le bon Tag (1 chiffer et 2 pour candidats)
   (Components[i] as TBitBtn).font.Color := Couleur;
end;

// ****************************************************
// Active ou Desactiver les boutons en fonction des candidats possibles
// ****************************************************
procedure TFrmSelecteur.Button_OnOff(listeCandidats : String; NumTag : Integer);
Var
 I : integer ;
begin
 For i := 0 to ComponentCount-1 do   // pour chaque composant
  If Components[i] is TBitBtn then   // de type TBitBtn
   If (Components[i] as TBitBtn).Tag = NumTag then // avec le bon Tag (1 chiffer et 2 pour candidats)
    (Components[i] as TBitBtn).Enabled :=  Pos((Components[i] as TBitBtn).Caption,listeCandidats)> 0;
end;

procedure TFrmSelecteur.FormShow(Sender: TObject);
begin
 Left := mouse.CursorPos.X;
 Top  := mouse.CursorPos.Y;
 Transparence := 255;
end;

procedure TFrmSelecteur.FormMouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
 Inc(Transparence,20);
 If Transparence > 255 then Transparence := 255;
 AlphaBlendValue := Transparence;
end;

procedure TFrmSelecteur.FormMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  Dec(Transparence,20);
 If Transparence < 60 then Transparence := 60;
 AlphaBlendValue := Transparence;
end;

end.
