unit UDmFonction;

interface

uses
  SysUtils,Classes,Forms,ShlObj,Windows,ActiveX,Inifiles,buttons,Comctrls,
  StdCtrls,ExtCtrls,Menus,Dialogs,Controls,ActnList,ActnMan,ExtActns,shellApi;

Const
 NomPublic = 'Sudoku Trainer'; // nom public de l'application connue dans Windows
 NONAME    = 'SansNom';        // Racine des noms de fichier non encore nomms
 EXT       = 'xml';            // Extension des fichiers pour ce projet
 Quote     = '''';             // incrit une ' dans un fichier lecture plus simple
 HeureVide = '00:00:00';       // affich lorsque le timer n'est pas actif
 Space     = chr(127)+chr(127)+chr(127)+chr(127);
type
 // Record d'une action type
 TActionSudoku  = record
   Ligne     : ShortInt;
   Colonne   : ShortInt;
   Chiffre   : ShortInt;
   Operation : String[1];
  End;


  TDMFonction = class(TDataModule)
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private
    { Dclarations prives }
   WinPosCorrection: Array[0..5] of TPoint;
   RecentFiles: TStringList;
   RecentFilesMICounter: integer; //used for naming RecentFileMenuItems
   function GetGlobalSettingsPath: string;
   function GetSpecialFolder(Folder: Integer): String;
   procedure LoadTranslatedMessages;

  public
    { Dclarations publiques }
   MessageCaptions    : TStringList;
   ProgName           : String;  // Nom du programme sur le Disque
   SettingsPath       : String;  // Chemin pour les datas dans mes documents
   Chemin             : String;  // chemin de l'application
   LanguageCode       : String;
   RecentOpenFileDir  : String;
   ReopenLastFile     : Boolean;
   ShowTipsOnStartup  : Boolean;
   SavePosWin         : Boolean;
   Toolbar_Visible    : Boolean;
   QuitConfirm        : Boolean;
   LastTipShown       : Integer;
   TimeSplash         : Integer;
   NonameCounter      : integer;
   CouleurChiffre     : integer;
   CouleurDevoile     : Integer;
   CouleurCandidat    : Integer;
   CouleurJouable     : Integer;
   CouleurReference   : Integer;
   CandidatsOnOff     : Boolean;
   ProtectionOnOff    : Boolean;


   procedure TranslateForm(theForm: TForm);
   procedure GetSectionFromTxtFile(filename, section: string; theStringList: TStringList; GetOnlyValues: Boolean = False);
   procedure LoadLanguageFromIniFile;
   procedure SaveLanguageToIniFile;
   procedure SetLanguageCode(LanguageCode: string);
   function  GetLanguageCode: string;
   procedure ResetProgramLanguage;
   procedure AppelBrowser(Chemin : String);
   function  ReplaceString(txt, such, ers: string): string;
   function  ReplaceString2(txt, such, ers: string): string;
   function  GetTranslatedMessage(OriginalMsg: string; MsgNr: integer; StrToInsert: string = ''; StrToInsert2: string = ''): string;
   function  MessageLocalise(Msg,StrToInsert1,StrToInsert2: String; Number: Integer; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons; Cod_Aide: Integer) : TModalResult;
   procedure TranslateLanguage(LaLangue: TMenuItem);
   function  LoadTip: string;
   function  ReplaceText2(txt, such, ers: string): string;
   function  ReplaceText(txt, such, ers: string): string;
   procedure SaveWinPos(win: TForm; DoSize: Boolean);
   procedure RestoreWinPos(win: TForm; DoSize: Boolean);
   function  GetRecentFileCount: integer;
   function  GetRecentFileName(id: integer): string;
   procedure OpenRecentFile(Sender: TObject);
   procedure AddFileToRecentFilesList(fname: string);
   function  GetNextNonameNumber: String;
   function  ExecuteProcess(f : shortstring; wait : boolean) : THandle;
   function  LoadValueFromSettingsIniFile(section, name, default: string): string;
   procedure SaveValueInSettingsIniFile(section, name, value: string);
   Function  RenvoiVersion():String;
   Function  SecondeToTemps(lesSecondes : Integer):String;

 end;

var
  DMFonction: TDMFonction;

implementation

uses UMain;


{$R *.dfm}


procedure TDMFonction.DataModuleCreate(Sender: TObject);
Var
 i : Integer;
begin
 RecentFiles         := TStringList.Create; // liste des fichers recents
 MessageCaptions     := TStringList.Create; // pour la liste des textes des messages dans la langue en cours
 RecentOpenFileDir   := '';
 RecentFilesMICounter:=1;
 NonameCounter:=0;
 for i:=0 to 5 do
  WinPosCorrection[i]:=Point(0, 0);

 Chemin   := ExtractFilePath(Application.ExeName); // chemin de l'application
 ProgName := Copy(ExtractFileName(Application.ExeName), 1,
             Length(ExtractFileName(Application.ExeName))-
             Length(ExtractFileExt(Application.ExeName)));

 SettingsPath    := GetGlobalSettingsPath; // chemin mes documents ou chemin de l'application voir la fonction
 LoadLanguageFromIniFile; // Chargement du code la langue courante
 LoadTranslatedMessages;  // chargement des textes dans la bonne langue
End;

procedure TDMFonction.DataModuleDestroy(Sender: TObject);
begin
 SaveLanguageToIniFile; // sauver les parametres globaux dans le ini
 // liberation des ressources
 MessageCaptions.Free;
 RecentFiles.Free;
end;

// ***********************************************************
// construction du chemin pour les sauvegardes de fichiers
// ***********************************************************
function TDMFonction.GetGlobalSettingsPath: string;
begin
   // soit
  SettingsPath:=GetSpecialFolder(CSIDL_COMMON_DOCUMENTS)+PathDelim+NomPublic+PathDelim;
  ForceDirectories(SettingsPath);
  //  soit
  //SettingsPath:=ExtractFilePath(Application.ExeName);
  //ForceDirectories(SettingsPath);

  GetGlobalSettingsPath:=SettingsPath;
end;

// *************************************
// Utile a GetGlobalSettingsPath
// *************************************
function TDMFonction.GetSpecialFolder(Folder: Integer): String;
var
  pMalloc: IMalloc;
  pidl: PItemIDList;
  Path: PChar;
begin
  if (SHGetMalloc(pMalloc) <> S_OK) then begin
    raise EInOutError.Create('Couldn''t get pointer to IMalloc interface.');

    Exit;
  end;
  SHGetSpecialFolderLocation(0, Folder, pidl);
  GetMem(Path, MAX_PATH);
  SHGetPathFromIDList(pidl, Path);
  Result := Path;
  FreeMem(Path);
  pMalloc.Free(pidl);
end;



// ******************************************************
// Appel d'une URL,URI ou fichier fichier local
// dans l'explorateur courant de Windows
// ******************************************************
procedure TDMFonction.AppelBrowser(Chemin : String);
Var
 browser :TbrowseURL;
begin
 Try
  browser := TBrowseURL.Create(self);
  browser.URL := Chemin;
  browser.ExecuteTarget(self);
 finally
  browser.Free;
 end;
end;


//***********************************
// Renvoi le numero de version de l'application
//***********************************
Function TDMFonction.RenvoiVersion():String;
var
 FileName: string;
 InfoSize, Wnd: DWORD;
 VerBuf: Pointer;
 FI: PVSFixedFileInfo;
 VerSize: DWORD;
begin
 Result  := '';
 FileName := Application.ExeName;
 InfoSize := GetFileVersionInfoSize(PChar(FileName), Wnd);
 if InfoSize <> 0 then
 begin
  GetMem(VerBuf, InfoSize);
  try
   if GetFileVersionInfo(PChar(FileName), Wnd, InfoSize, VerBuf) then
    if VerQueryValue(VerBuf, PathDelim, Pointer(FI), VerSize) then
    Begin
     Result  := InttoStr(StrToInt(Copy(IntToHex(FI.dwFileVersionMS,8),1,4)));
     Result  := Result +'.'+InttoStr(StrToInt(Copy(IntToHex(FI.dwFileVersionMS,8),5,4)));
     Result  := Result + InttoStr(StrToInt(Copy(IntToHex(FI.dwFileVersionLS,8),1,4)));
    end;
  finally
   FreeMem(VerBuf);
  end;
 end;
end;



          //******************************************
          //****** Fonctions ini *********************
          //******************************************


//*****************************************************************
// Fonction generique de lecture dans le Ini
//*****************************************************************
function TDMFonction.LoadValueFromSettingsIniFile(section, name, default: string): string;
var
 theIni: TMemIniFile;
begin
  //Read IniFile
  theIni:=TMemIniFile.Create(SettingsPath+'Settings.ini');
  try
   LoadValueFromSettingsIniFile:=  theIni.ReadString(section, name, default);
  finally
   theIni.Free;
  end;
end;
//*****************************************************************
// Fonction generique d'ecriture dans le Ini
//*****************************************************************
procedure TDMFonction.SaveValueInSettingsIniFile(section, name, value: string);
var
 theIni: TMemIniFile;
begin
  //Write IniFile
  theIni:=TMemIniFile.Create(SettingsPath+'Settings.ini');
  try
    theIni.WriteString(section, name, value);
    theIni.UpdateFile;
  finally
    theIni.Free;
  end;
end;

// ******************************************************
// Chargement des parametres globaux dans le ini
// ******************************************************
procedure TDMFonction.LoadLanguageFromIniFile;
var
 theIni       : TMemIniFile;
begin
  try
   theIni        :=TMemIniFile.Create(SettingsPath+'Settings.ini');

   LanguageCode      :=theIni.ReadString('GeneralSettings', 'Language', 'fr');
   ShowTipsOnStartup :=theIni.ReadBool('GeneralSettings', 'ShowTipsOnStartup', True);
   SavePosWin        :=theIni.ReadBool('GeneralSettings', 'SavePosWin',True);
   Toolbar_Visible   :=theIni.ReadBool('GeneralSettings', 'ToolBar',True);
   QuitConfirm       :=theIni.ReadBool('GeneralSettings', 'QuitConfirm',True);
   LastTipShown      :=theIni.ReadInteger('GeneralSettings', 'LastTipShown', 0);
   TimeSplash        :=theIni.ReadInteger('GeneralSettings', 'TimeSplash', 2);
   ReopenLastFile    :=theIni.ReadBool('GeneralSettings', 'ReopenLastFile',True);
   RecentOpenFileDir :=theIni.ReadString('RecentDirectories', 'RecentOpenFileDir', '');
   CouleurChiffre    :=theIni.ReadInteger('GeneralSettings', 'CouleurChiffre', 16711680);
   Couleurdevoile    :=theIni.ReadInteger('GeneralSettings', 'Couleurdevoile', 0);
   CouleurCandidat   :=theIni.ReadInteger('GeneralSettings', 'CouleurCandidat', 16744576);
   CouleurReference  :=theIni.ReadInteger('GeneralSettings', 'CouleurReference', 65535);
   CouleurJouable    :=theIni.ReadInteger('GeneralSettings', 'CouleurJouable', 65408);
   CandidatsOnOff    :=theIni.ReadBool('GeneralSettings', 'Candidats',False);
   ProtectionOnOff   :=theIni.ReadBool('GeneralSettings', 'Protection',False);

  finally
   theIni.Free;
  end;
  if(RecentOpenFileDir='')then
    RecentOpenFileDir:= SettingsPath;
end;

// ******************************************************
// Sauvegarde des parametres globaux dans le ini
// ******************************************************
procedure TDMFonction.SaveLanguageToIniFile;
var
 theIni: TMemIniFile;
 I : Integer;
begin
  theIni:=TMemIniFile.Create(SettingsPath+'Settings.ini');
  try
   theIni.WriteString('GeneralSettings', 'Language', LanguageCode);
   theIni.WriteBool('GeneralSettings', 'ShowTipsOnStartup',ShowTipsOnStartup);
   theIni.WriteBool('GeneralSettings', 'SavePosWin',SavePosWin);
   theIni.WriteBool('GeneralSettings', 'ToolBar',Toolbar_Visible);
   theIni.WriteBool('GeneralSettings', 'QuitConfirm',QuitConfirm);
   theIni.WriteInteger('GeneralSettings', 'LastTipShown',LastTipShown);
   theIni.WriteInteger('GeneralSettings', 'TimeSplash',TimeSplash);
   theIni.WriteBool('GeneralSettings', 'ReopenLastFile',ReopenLastFile);
   theIni.WriteString('RecentDirectories', 'RecentOpenFileDir', RecentOpenFileDir);
   theIni.WriteInteger('GeneralSettings', 'CouleurChiffre',CouleurChiffre);
   theIni.WriteInteger('GeneralSettings', 'CouleurCandidat',CouleurCandidat);
   theIni.WriteInteger('GeneralSettings', 'Couleurdevoile',Couleurdevoile);
   theIni.WriteInteger('GeneralSettings', 'CouleurJouable',CouleurJouable);
   theIni.WriteInteger('GeneralSettings', 'CouleurReference',CouleurReference );
   theIni.WriteBool('GeneralSettings', 'Candidats',CandidatsOnOff );
   theIni.WriteBool('GeneralSettings', 'Protection',ProtectionOnOff);



   theIni.EraseSection('RecentFiles');
   for i:=0 to RecentFiles.Count-1 do
      theIni.WriteString('RecentFiles', 'File'+IntToStr(i+1), RecentFiles[i]);
    theIni.UpdateFile;
  finally
   theIni.Free;
  end;
end;

// ******************************************************
// Charge et renvoi  de la prochaine astuce (Tips)
// ******************************************************

function TDMFonction.LoadTip: string;
var theStringList: TStringList;
begin
  LoadTip:='';
  theStringList:=TStringList.Create;
  try
    DMFonction.GetSectionFromTxtFile(Chemin+'Translations.txt','Tips', theStringList, True);
    if(theStringList.Text='')then
    begin
      LoadTip:='';
      ShowTipsOnStartup:=False;
    end
    else
    begin
      inc(LastTipShown);
      if(LastTipShown>theStringList.Count-1)then
        LastTipShown:=0;
      LoadTip:=ReplaceText(theStringList[DMFonction.LastTipShown], '#13#10', #13#10);
    end
  finally
    theStringList.Free;
  end;
end;

// ******************************************************
// Ajout d'un item de menu  la liste des fichers recents
// ******************************************************
procedure TDMFonction.AddFileToRecentFilesList(fname: string);
var theMenuItem: TMenuItem;
  oldPos: integer;
begin
  if(RecentFiles.IndexOf(fname)=-1)and(FileExists(fname))then
  begin
    RecentFiles.Insert(0, fname);

    theMenuItem:=TMenuItem.Create(FormMain);
    inc(RecentFilesMICounter);
    theMenuItem.Name:='OpenRecent'+IntToStr(RecentFilesMICounter+1)+'MI';
    theMenuItem.Caption:=ExtractFileName(fname);
    theMenuItem.OnClick:=OpenRecentFile;

    FormMain.OpenRecentMI.Insert(0, theMenuItem);

    if(RecentFiles.Count>10)then
    begin
      RecentFiles.Delete(10);
      theMenuItem:=FormMain.OpenRecentMI[10];
      FormMain.OpenRecentMI.Delete(10);
      theMenuItem.Free;
    end;
  end
  else if(RecentFiles.IndexOf(fname)>0)and(FileExists(fname))then
  begin
    oldPos:=RecentFiles.IndexOf(fname);
    RecentFiles.Delete(oldPos);
    RecentFiles.Insert(0, fname);

    theMenuItem:=FormMain.OpenRecentMI[oldPos];
    FormMain.OpenRecentMI.Delete(oldPos);
    FormMain.OpenRecentMI.Insert(0, theMenuItem);
  end;
end;

//****************************************************
// compte le nombre de fichier recent existant
//****************************************************
function TDMFonction.GetRecentFileCount: integer;
begin
  GetRecentFileCount:=RecentFiles.Count;
end;

//****************************************************
// Renvoi le nom du fichier pass en ID
//****************************************************
function TDMFonction.GetRecentFileName(id: integer): string;
begin
 GetRecentFileName:=RecentFiles[id];
end;

//****************************************************
// Ouvre le dernier fichier recent
//****************************************************
procedure TDMFonction.OpenRecentFile(Sender: TObject);
begin
 FormMain.OpenFile(GetRecentFileName(FormMain.OpenRecentMI.IndexOf(TMenuItem(Sender))));
end;


//****************************************************
// Sauve la position de la fenetre passe en parametre
// dans le fichier ini
//****************************************************
procedure TDMFonction.SaveWinPos(win: TForm; DoSize: Boolean);
var
 winname: string;
 theIni: TMemIniFile;
 P: TPoint;
begin
  If not SavePosWin then exit;
  winname:=win.name;
  P:=win.ClientToScreen(Point(0, 0));
  theIni:=TMemIniFile.Create(SettingsPath+'Settings.ini');
  try
    if win.WindowState =wsMaximized then
      theIni.WriteInteger('WindowPositions', winname+'State', 1)
    else
    begin
      theIni.WriteInteger('WindowPositions', winname+'State', 0);
      if(P.X>0)then
        theIni.WriteInteger('WindowPositions', winname+'Left', P.X)
      else
        theIni.WriteInteger('WindowPositions', winname+'Left', 15);

      if(P.Y>0)then
        theIni.WriteInteger('WindowPositions', winname+'Top', P.Y)
      else
        theIni.WriteInteger('WindowPositions', winname+'Top', 15);

      if(DoSize)then
      begin
        theIni.WriteInteger('WindowPositions', winname+'Width', win.Width);

        theIni.WriteInteger('WindowPositions', winname+'Height', win.Height);
      end;
    end;

    theIni.UpdateFile;
  finally
    theIni.Free;
  end;
end;



//****************************************************
// Restaure la position de la fenetre passe en parametre
// depuis les donnes du fichier ini
//****************************************************
procedure TDMFonction.RestoreWinPos(win: TForm; DoSize: Boolean);
var
  theIni: TMemIniFile;
  winname: string;
  P: TPoint;
  WinPos: TPoint;
begin
 If not SavePosWin then exit;
  winname:=win.name;
  //Read IniFile
  theIni:=TMemIniFile.Create(SettingsPath+'Settings.ini');
  try
    try
      WinPos.X:=theIni.ReadInteger('WindowPositions', winname+'Left', 80);
      WinPos.Y:=theIni.ReadInteger('WindowPositions', winname+'Top', 140);
      if(WinPos.X>Screen.Width)then
        WinPos.X:=Screen.Width-50;
      if(WinPos.Y>Screen.Height)then
        WinPos.Y:=Screen.Height-50;

      win.Left:=WinPos.X-WinPosCorrection[Ord(win.BorderStyle)].X;
      win.Top:=WinPos.Y-WinPosCorrection[Ord(win.BorderStyle)].Y;

      P:=win.ClientToScreen(Point(0, 0));
      if(P.X<>WinPos.X)or(P.Y<>WinPos.Y)then
      begin
        WinPosCorrection[Ord(win.BorderStyle)].X:=P.X-WinPos.X;
        WinPosCorrection[Ord(win.BorderStyle)].Y:=P.Y-WinPos.Y;

        win.Left:=WinPos.X-WinPosCorrection[Ord(win.BorderStyle)].X;
        win.Top:=WinPos.Y-WinPosCorrection[Ord(win.BorderStyle)].Y;
      end;

      if(win.Top<0)then
        win.Top:=0;
      if(DoSize)then
      begin
        win.Width:=
          theIni.ReadInteger('WindowPositions', winname+'Width', 140);
        win.Height:=
          theIni.ReadInteger('WindowPositions', winname+'Height', 140);
        if(theIni.ReadInteger('WindowPositions', winname+'State', 0)=1)then
          win.WindowState:=wsMaximized;
      end;
    except
      win.Left:=((Application.MainForm.Left+Application.MainForm.Width)-win.Width) div 2-40;
      win.Top:=((Application.MainForm.Top+Application.MainForm.Height)-win.Height) div 2;

    end;
  finally
    theIni.Free;
  end;
end;


          //****************************************************
          // ROUTINES POUR LA LOCALISATION (LANGUES)
          //****************************************************



//****************************************************
// Renvoi le code language fr ,en, de etc...
//****************************************************
function TDMFonction.GetLanguageCode: string;
begin
 GetLanguageCode:=LanguageCode;
end;

//****************************************************
// Fixe un nouveau code language et prise en compte
// dans le programme aussitot
//****************************************************
procedure TDMFonction.SetLanguageCode(LanguageCode: string);
begin
  self.LanguageCode:=LanguageCode;
  SaveLanguageToIniFile;
  ResetProgramLanguage;
end;

//****************************************************
// Recharge une interface avec une nouvelle langue
//****************************************************
procedure TDMFonction.ResetProgramLanguage;
var i: integer;
begin
  LoadTranslatedMessages;
  for i:=0 to Screen.FormCount-1 do
    TranslateForm(Screen.Forms[i]);
end;

//****************************************************
// charge les textes dans la langue courante
//****************************************************
procedure TDMFonction.LoadTranslatedMessages;
begin
  if(Not(FileExists(Chemin+'Translations.txt')))then
   Exit;
  GetSectionFromTxtFile(Chemin+'Translations.txt','Messages', MessageCaptions, True);
end;


procedure TDMFonction.GetSectionFromTxtFile(filename, section: string; theStringList: TStringList; GetOnlyValues: Boolean = False);
var tmpStringList: TStringList;
  i: integer;
  SectionReached: Boolean;
begin
  theStringList.Clear;

  tmpStringList:=TStringList.Create;
  try
    tmpStringList.LoadFromFile(filename);
    i:=0;
    SectionReached:=False;
    while(i<tmpStringList.Count)do
    begin
      if(Not(SectionReached))then
      begin
        if(tmpStringList[i]='['+section+']')then
          SectionReached:=True;
      end
      else
      begin
        if(Copy(tmpStringList[i], 1, 1)<>'[')then
        begin
          if(Copy(tmpStringList[i], 1, 2)=LanguageCode)then
            if(GetOnlyValues)then
              theStringList.Add(tmpStringList.ValueFromIndex[i])
            else
              theStringList.Add(tmpStringList[i]);
        end
        else
          break;
      end;

      inc(i);
    end;
  finally
    tmpStringList.Free;
  end;
end;

procedure TDMFonction.TranslateForm(theForm: TForm);
var theStringList: TStringList;
  i: integer;
  trans_caption, trans_hint, s1: string;
begin
  if(Not(FileExists(Chemin+'Translations.txt')))then
    Exit;

  theStringList:=TStringList.Create;
  try
    GetSectionFromTxtFile(Chemin+'Translations.txt',
      theForm.Name, theStringList);

    for i:=0 to theForm.ComponentCount-1 do
    begin
      s1:=LanguageCode+'_'+theForm.Components[i].ClassName+'_';
      s1:=s1+theForm.Components[i].Name;
      trans_caption:=ReplaceString(theStringList.Values[s1], '\039', '''');
      trans_hint:=ReplaceString(ReplaceString(theStringList.Values[s1+'_Hint'], '\039', ''''), '\n', #13#10);
      if(trans_caption<>'')then
      begin
        if(theForm.Components[i].ClassParent=TForm)then
          TForm(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TAction'))then
          TAction(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TSpeedButton'))then
          TSpeedButton(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TBitBtn'))then
          TBitBtn(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TTabSheet'))then
          TTabSheet(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TLabel'))then
          TLabel(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TPanel'))then
          TPanel(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TGroupBox'))then
          TGroupBox(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TMenuItem'))then
          TMenuItem(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TCheckBox'))then
          TCheckBox(theForm.Components[i]).Caption:=trans_caption
        else if(theForm.Components[i].ClassNameIs('TRadioButton'))then
          TRadioButton(theForm.Components[i]).Caption:=trans_caption;
      end;

      if(trans_hint<>'')then
      begin
        if(theForm.Components[i].ClassParent=TForm)then
          TForm(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TSpeedButton'))then
          TSpeedButton(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TAction'))then
          TAction(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TBitBtn'))then
          TBitBtn(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TTabSheet'))then
          TTabSheet(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TLabel'))then
          TLabel(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TPanel'))then
          TPanel(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TGroupBox'))then
          TGroupBox(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TMenuItem'))then
          TMenuItem(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TCheckBox'))then
          TCheckBox(theForm.Components[i]).Hint:=trans_hint
        else if(theForm.Components[i].ClassNameIs('TRadioButton'))then
          TRadioButton(theForm.Components[i]).Hint:=trans_hint;
      end;
    end;
  finally
    theStringList.Free;
  end;
end;

procedure TDMFonction.TranslateLanguage(LaLangue: TMenuItem);
var theStringList: TStringList;
  i: integer;
  trans_caption, s1: string;
begin
 if(Not(FileExists(Chemin+'Translations.txt')))then
  Exit;
 theStringList:=TStringList.Create;
 try
  GetSectionFromTxtFile(Chemin+'Translations.txt', LaLangue.Name, theStringList);
  for i:=0 to LaLangue.ComponentCount-1 do
  begin
   s1:=LanguageCode+'_'+LaLangue.Components[i].ClassName+'_'+LaLangue.Components[i].Name;
   trans_caption:=ReplaceString(theStringList.Values[s1], '\039', '''');
   if(trans_caption<>'')then
    TMenuItem(LaLangue.Components[i]).Caption:=trans_caption ;
  end;
 finally
  theStringList.Free;
 end;
end;

function TDMFonction.ReplaceString(txt, such, ers: string): string;
begin
  ReplaceString:=ReplaceString2(ReplaceString2(txt, such, ''), '', ers);
end;

function TDMFonction.ReplaceString2(txt, such, ers: string): string;
begin
  while(Pos(such, txt)>0)do
    txt:=Copy(txt, 1, Pos(such, txt)-1)+ers+
      Copy(txt, Pos(such, txt)+Length(such), Length(txt));
  ReplaceString2:=txt;
end;



function TDMFonction.GetTranslatedMessage(OriginalMsg: string; MsgNr: integer; StrToInsert: string = ''; StrToInsert2: string = ''): string;
var s: string;
begin
  if(MsgNr>=0)and(MsgNr<=MessageCaptions.Count)then
    s:=MessageCaptions[MsgNr-1]
  else
    s:=OriginalMsg;

  if(Pos('%s', s)>0)then
    s:=Copy(s, 1, Pos('%s', s)-1)+StrToInsert+Copy(s, Pos('%s', s)+2, Length(s));

  if(Pos('%s', s)>0)then
    s:=Copy(s, 1, Pos('%s', s)-1)+StrToInsert2+Copy(s, Pos('%s', s)+2, Length(s));
  s:=ReplaceString(s, '\n', #13#10);
  s:=ReplaceString(s, '\039', '''');
  s:=ReplaceString(s, '\\', '\');
  GetTranslatedMessage:=s;
end;

function TDMFonction.ReplaceText(txt, such, ers: string): string;
begin
  ReplaceText:=ReplaceText2(ReplaceText2(txt, such, ''), '', ers);
end;

function TDMFonction.ReplaceText2(txt, such, ers: string): string;
begin
  while(Pos(UpperCase(such), UpperCase(txt))>0)do
    txt:=Copy(txt, 1, Pos(UpperCase(such), UpperCase(txt))-1)+ers+
      Copy(txt, Pos(UpperCase(such), UpperCase(txt))+Length(such), Length(txt));

  ReplaceText2:=txt;
end;



function TDMFonction.MessageLocalise(Msg,StrToInsert1,StrToInsert2: String; Number: Integer; DlgType: TMsgDlgType; Buttons: TMsgDlgButtons; Cod_Aide: Integer) : TModalResult;
var i : Integer;
begin
 Msg   := GetTranslatedMessage(Msg,Number,StrToInsert1,StrToInsert2);
  With CreateMessageDialog(Msg, DlgType, Buttons) Do
     Try
        Case DlgType  Of
         mtWarning      : Caption := GetTranslatedMessage('Warning',12);
         mtError        : Caption := GetTranslatedMessage('Erreur',13);
         mtInformation  : Caption := GetTranslatedMessage('Information',14);
         mtConfirmation : Caption := GetTranslatedMessage('Confirmation',15);
         mtCustom       : Caption := GetTranslatedMessage(NomPublic,16);
       end;

       HelpContext := Cod_Aide;

       for i:= 0 To ComponentCount - 1 Do
         If Components[i] Is TButton
         Then
           Case (Components[i] As TButton).ModalResult Of
             mrNone : (Components[i] As TButton).Caption :=  GetTranslatedMessage('A&ide',11);
             mrAbort : (Components[i] As TButton).Caption := GetTranslatedMessage('A&bandonner',5);
             mrAll : (Components[i] As TButton).Caption := GetTranslatedMessage('&Tout',8);
             mrCancel : (Components[i] As TButton).Caption := GetTranslatedMessage('&Annuler',4);
             mrIgnore : (Components[i] As TButton).Caption := GetTranslatedMessage('I&gnorer',7);
             mrNo : (Components[i] As TButton).Caption := GetTranslatedMessage('&Non',2);
             mrNoToAll : (Components[i] As TButton).Caption := GetTranslatedMessage('&Non a to&us',9);
             mrOk : (Components[i] As TButton).Caption := GetTranslatedMessage('O&k',3);
             mrRetry : (Components[i] As TButton).Caption := GetTranslatedMessage('R&epeter',6);
             mrYes : (Components[i] As TButton).Caption := GetTranslatedMessage('&Oui',1);
             mrYesToAll : (Components[i] As TButton).Caption := GetTranslatedMessage('&Oui a tou&s',10);
           End;


       RESULT := ShowModal;
     Finally
       Free;
     End;
end;

//*********************************************
// inc un compteur depuis le lancement du prog
// pour les fichiers sansNom
//*********************************************
function TDMFonction.GetNextNonameNumber: String;
begin
  inc(NonameCounter);
  GetNextNonameNumber:=IntToStr(NonameCounter);
end;

//********************************************************
// Renvoi une dure en J HM S en fonction d'un nombre de
// secondes passs en parametres
//********************************************************
Function  TDMFonction.SecondeToTemps(lesSecondes : Integer):String;
Var
  heure, minute,seconde : Word;
  NbDeSeconde : Integer;
Begin
 NbDeSeconde   := lesSecondes;
 heure         := (NbDeSeconde Div 3600);
 NbDeSeconde   := NbDeSeconde - (3600 * heure);
 minute        := (NbDeSeconde Div 60);
 NbDeSeconde   := NbDeSeconde - (60 * minute);
 seconde       := NbDeSeconde ;
 result        := StringOfChar('0',2-Length(intToStr(heure)))+ intToStr(heure)+':';
 result        := result + StringOfChar('0',2-Length(intToStr(minute)))+ intToStr(minute)+':';
 result        := result + StringOfChar('0',2-Length(intToStr(seconde)))+ intToStr(seconde);
End;


//*********************************************
// Lance un process
// sert pour les plugins a venir
//*********************************************
function TDMFonction.ExecuteProcess(f : shortstring; wait : boolean) : THandle;
var
  si : TStartupInfo;
  pi : TProcessInformation;

  src : array[0..255] of char;
  exitCode : dword;
begin
  {initialise la structure StartupInfo }
  ZeroMemory(@si, sizeof(si));
  si.cb:=sizeof(si);

  { copie la chaine Pascal en PChar }
  strPCopy(src, f);
  if not CreateProcess(nil, src, nil, nil, true, 0, nil, nil, si, pi) then
    raise Exception.create('Impossible de lancer l''application '+f);

  { attend l'excution du processus lanc si la coche Attendre est positionne }
  if wait then begin
    if (WaitForSingleObject(pi.hProcess, INFINITE) <> WAIT_FAILED) then
      GetExitCodeProcess(pi.hProcess, exitCode);
  end;

  result:=pi.hProcess;
end;





end.
