unit UFrame;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, 
  Dialogs, StdCtrls, ExtCtrls, Grids, CheckLst, Buttons, ComCtrls,UDmFonction,
  UMain, SudoSelecteur, UAnalyse,Printers,shellAPI;
const
 NbFamille = 6; // 6 familles de 0  5

type
  TFramefille = class(TFrame)
    PrintDialog1: TPrintDialog;
    MemoClipboard: TMemo;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label6: TLabel;
    LabelVersion: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    GBTimer: TGroupBox;
    LabelTimer: TLabel;
    Image1: TImage;
    GroupBox3: TGroupBox;
    BT_REFAIRE: TBitBtn;
    BT_EFF_TOUT: TBitBtn;
    Bt_PRECEDENT: TBitBtn;
    GroupBox5: TGroupBox;
    SB_CandidatOn: TSpeedButton;
    SB_CandidatOff: TSpeedButton;
    GroupBox4: TGroupBox;
    SB_ProtectionOn: TSpeedButton;
    SB_ProtectionOff: TSpeedButton;
    GBCaseAtrouver: TGroupBox;
    LabelCases: TLabel;
    Image2: TImage;
    GBMode: TGroupBox;
    BtJouer: TBitBtn;
    TabSheet2: TTabSheet;
    MemoTrace: TMemo;
    TabSheet3: TTabSheet;
    CheckListFamille: TCheckListBox;
    StringGrid: TStringGrid;
    Shape1: TShape;
    Label1: TLabel;
    Label2: TLabel;
    Image4: TImage;
    Shape3: TShape;
    Shape2: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Panel1: TPanel;
    Save2DiskImg: TImage;
    Save2DiskDisabledImg: TImage;
    LbStatus: TLabel;
    TaskDialogSave: TTaskDialog;
    TimerPartie: TTimer;
    procedure SB_CandidatOnClick(Sender: TObject);
    procedure SB_ProtectionOnClick(Sender: TObject);
    procedure Bt_PRECEDENTClick(Sender: TObject);
    procedure BT_EFF_TOUTClick(Sender: TObject);
    procedure BtJouerClick(Sender: TObject);
    procedure CheckListFamilleClick(Sender: TObject);
    procedure CheckListFamilleClickCheck(Sender: TObject);
    procedure StringGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGridDblClick(Sender: TObject);
    procedure BT_REFAIREClick(Sender: TObject);
    procedure TimerPartieTimer(Sender: TObject);
    procedure Label5Click(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure Label5MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TabSheet1MouseEnter(Sender: TObject);
  private
    IsChanged        : Boolean;
    procedure AfficherSelecteur(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

    { Dclarations prives }
  public
    { Dclarations publiques }
    // variables Compteur et recorder
    DureePartie : Integer;
    Recorder  : array [0..1000] of TActionSudoku; // prevoyons large
    PositionRecorder : Integer;
    // variables pour les impressions
    CoeffX      : Double ;
    CoeffY      : Double ;
    MargeHaute  : Integer; // Taille de la zone du haut dans laquelle l'imprimante ne peut pas crire
    MargeGauche : Integer; // Taille de la zone de gauche dans laquelle l'imprimante ne peut pas crire
    OffsetGauche : Integer;
    OffsetHaut  : Integer;

    // Variables listes et compteur pour les analyses et recherches
    GrilleActuelle    : TGrille; // grille passe en parametre aux algos de recherche
    ListeDecouvertes  : TListDec; // liste des decouvertes
    PCDec             : Byte; // indice du Poste Courante des decouvertes
    NbDeDecouverte    : ShortInt;

    // Variables pour les chemins de fichier et divers noms
    ModeCourant      : String;  // 'S' pour Saisie 'R' pour rsolution
    CheminCourant    : String;     // chemin et nom du fichier
    AvoirNom         : Boolean;
    procedure  CreerPlateau;
    //******* routines fichiers disque ************/
    procedure SaveToFile; // sauver le fichier su disque
    procedure LoadFromFile;// charger le fichier depuis le disque
    procedure SetChanged(Change : Boolean); // passe IsChanged ON/OFF + maj du contexte
    function  GetChanged: Boolean; // renvoi True si le fichier est modifi
    function  fermer: Boolean;
    //********  routines partie de sudoku **********//
    procedure ToutRejouer;
    procedure MettreCouleurCandidat;
    procedure Mode(Mode : String; Enregistrer : Boolean);
    procedure JouerCoup(Ligne,Colonne,Chiffre : Integer ; Operation : String);
    procedure JouerPreference;
    //procedure TimerPartieTimer(Sender: TObject);
    Function  compteRestant(): Integer;

    //*********** Routines impression *************//
    procedure DessinCandidats(Ligne, Colonne: Integer; TabCand: String);
    procedure DessinChiffre(Ligne, Colonne: Integer; Chiffre: String);
    procedure DessinGrille;
    procedure ImprimerJuste(LeX, LeY: integer; LeChiffre: String);
    procedure ImprimerTrait(LeX, leY, Longueur, Epaisseur: integer;
      Sens: String);
    procedure initialiseImprimante;
    procedure SelectionFonte(Name: String; size: Integer;
      FontStyle: TFontStyles);
    procedure Imprimer;

    //*********** Routines analyse *************//
    procedure Analyser;
    procedure JouerAnalyse;
    procedure SudokuToGrille;
    procedure ViderAnalyses;
    procedure NettoyerStringGrid;
    Function  JouerFamille(Famille : ShortInt):Boolean;


    //*********** Routines CopierColler *************//
    procedure GRilleToPP;
    procedure PPToGrille;
    procedure ChaineToGRille(Chaine : String);
  end;

implementation

uses SudoCase;





{$R *.dfm}

procedure TFramefille.CreerPlateau;
 Var
 I,J: Integer ;
 Sudocase1 : TSudoCase;
begin
 PositionRecorder := -1;
 SetChanged(false);
 For I := 1 to 9 do
  For J := 1 to 9 do
  begin
   Sudocase1 := TSudoCase.create(self);
   // partie Nom
   Sudocase1.Ligne   := J;
   Sudocase1.Colonne := I;
   Sudocase1.Name := 'L'+IntToStr(J)+'C'+IntToStr(I)+'R'+IntToStr(Sudocase1.Region);
   Sudocase1.Parent     := Self;
   Sudocase1.Left       := 25 +((I-1)*46);
   Sudocase1.Top        := 25 +((j-1)*46);
   Sudocase1.CouleurCandidat := DMFonction.CouleurCandidat;
   Sudocase1.Shape  := stRoundSquare;
   Sudocase1.Pen.Color := Clblue;
   Sudocase1.ViewCandidat  := False;
   Sudocase1.Brush.Color   := clwhite;
   Sudocase1.Hint := Sudocase1.Name;
   Sudocase1.ShowHint := True;
   Sudocase1.OnMouseUp  := AfficherSelecteur;
  End;       { TODO : traduire }
  LabelVersion.Caption := 'Version : '+DMFonction.RenvoiVersion;
  Mode('S',True); // l'ecran etant vide de tout , le mode Saisie sera actif
  JouerPreference ;

  // ******* au cas ou la fentre est instancie par une copie ************//
  // *******      alors le recoderTMP est a rejouer            ************//
  If FormMain.PositionRecorderTMP>0 then
  Begin
   For i := 0 to FormMain.PositionRecorderTMP do
    Recorder[i] := FormMain.RecorderTMP[I];
   PositionRecorder := FormMain.PositionRecorderTMP;
   FormMain.PositionRecorderTMP := 0;
   ToutRejouer;
   DureePartie := FormMain.DureePartieTMP;
  end;
  // *********  Fin de copie de la grille *************//
end;
procedure TFramefille.AfficherSelecteur(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
Var
 Retour         : TModalResult;
 CurrentLigne   : Integer;
 CurrentColonne : Integer;
 I              : Integer;
 Chiffre        : String;
 Operation      : String;
 FrmSelecteur   : TFrmSelecteur;
Begin
  Try
  // Instancier un selecteur
  FrmSelecteur := TFrmSelecteur.create(Self);

  DMFonction.TranslateForm(FrmSelecteur); // choix de la langue
  FrmSelecteur.caption := DMFonction.GetTranslatedMessage('Selecteur',44);

  // mettre a jour les couleurs et l'etat des boutons du selecteur
  IF ModeCourant = 'R' then
  begin
   (Sender as TSudoCase).CouleurChiffre := DMFonction.CouleurChiffre;
   FrmSelecteur.Couleur(DMFonction.CouleurChiffre,1);
   IF  SB_ProtectionOn.Down then
   Begin
    FrmSelecteur.Button_OnOff((Sender as TSudoCase).RenvoiCandidats ,1); // les chiffres
    FrmSelecteur.Button_OnOff((Sender as TSudoCase).RenvoiCandidats ,2); // Les candidats
   end;
  end
  else
  begin
   (Sender as TSudoCase).CouleurChiffre := DMFonction.CouleurDevoile;
   FrmSelecteur.Couleur(DMFonction.CouleurDevoile,1);
   IF  SB_ProtectionOn.Down then
   Begin
    FrmSelecteur.Button_OnOff((Sender as TSudoCase).RenvoiCandidats ,1); // les chiffres
    FrmSelecteur.Button_OnOff('',2); // aucun candidat actif en mode saisie
   end;
  End;
  If Button = mbLeft then
   // la page des chiffres sera affiche
   FrmSelecteur.PageControl1.ActivePageIndex := 0
  else
   FrmSelecteur.PageControl1.ActivePageIndex := 1;

  // mettre la bonne couleur pour les candidats
  FrmSelecteur.Couleur(DMFonction.CouleurCandidat,2);


  // positionner le selecteur

  // afficher le selecteur
  Retour := FrmSelecteur.ShowModal;
  update;
  // si annulation on sort
  IF Retour = MrCancel then exit;
  // recup de la ligne et de la colonne
  CurrentLigne   := (Sender as TSudoCase).Ligne;
  CurrentColonne := (Sender as TSudoCase).Colonne;
  // recup du chiffre a poser
  Chiffre := FrmSelecteur.ActiveControl.Name[2];
  // recup si chiffre a poser 'P' ou candisats a enlever 'C'
  Operation := FrmSelecteur.ActiveControl.Name[1];

  // ecrire dans le recorder
  Inc(PositionRecorder);
  JouerCoup(CurrentLigne,CurrentColonne,StrToInt(Chiffre),Operation);
  Recorder[PositionRecorder].Ligne   := CurrentLigne;
  Recorder[PositionRecorder].Colonne := CurrentColonne ;
  Recorder[PositionRecorder].Chiffre := StrToInt(Chiffre);
  Recorder[PositionRecorder].Operation := Operation;
  SetChanged(True); // il faudra sauvegarder

  // test si y'a pas une erreur dans la grille

  // si reste 0 candidats et case toujours vide
  For I := 0 to ComponentCount-1 do
   If Components[I] is TSudoCase then
   begin
    IF (Components[i]as TSudoCase).Number = '' then
    IF (Components[i]as TSudoCase).CompterFlag = 0 then
     begin
       MessageBeep(0);    { TODO : traduire }
       Memotrace.lines.Add('FAUX - L'+ IntToStr((Components[i]as TSudoCase).ligne) + '  C'+ IntToStr((Components[i]as TSudoCase).Colonne) + '  sans candidats.');
     end;
   End;
  If ModeCourant = 'R' then
   Analyser;
 Finally
  FrmSelecteur.Free;
 end;
end;
procedure TFramefille.JouerCoup(Ligne,Colonne,Chiffre : Integer ; Operation : String);
//******************************************************
// Joue un coup dans la grille
//******************************************************

Var
 i             : Integer;
 CurrentRegion : Integer;
begin
 For i := 0 to ComponentCount-1 do
  If Components[i] is TSudoCase then
   If (Components[i]as TSudoCase).Ligne = Ligne then
    If (Components[i]as TSudoCase).Colonne = Colonne then
    begin
     // le bon composant TSudocase est trouv
     CurrentRegion := (Components[i]as TSudoCase).Region; // recupration de la region

     // *********  Traitement de suppression d'un candidats dans une case ***********//
     If Operation = 'C' then
     Begin
      (Components[i]as TSudoCase).ClearCandidat(Chiffre);
      If modeCourant = 'R' then               { TODO : traduire }
       Memotrace.Lines.Add('L'+ IntToStr((Components[i]as TSudoCase).Ligne)+' C'+ IntToStr(Colonne) + ' suppression du candidat : '+ IntToStr(Chiffre));
      Exit;
     End;
     // *********  Traitement de poser un chiffre dans une case ***********//
     If Operation = 'P' then  // P= Poser un chiffre
     begin
      IF not (Components[i] as TSudoCase).ExistCandidat(Chiffre) then
      begin
       If (Components[i] as TSudoCase).Number<>IntTostr(Chiffre) then
       begin
        MessageBeep(0);             { TODO : traduire }
        Memotrace.Lines.Add('FAUX - L'+ IntToStr(Ligne)+' C'+ IntToStr(Colonne) + 'le '+ IntTostr(Chiffre) + ' dj pos.');
       End;
      end;
      // ******** Choix de la bonne couleur ********//
      If ModeCourant = 'S' then
       (Components[i]as TSudoCase).CouleurChiffre := DMFonction.CouleurDevoile
      Else
      (Components[i]as TSudoCase).CouleurChiffre := DMFonction.CouleurChiffre;

      // pose le chiffre dans la case
     (Components[i]as TSudoCase).Number := intTostr(Chiffre);

      // Informe le traceur de coups
      If modeCourant = 'R' then           { TODO : traduire }
       Memotrace.Lines.Add('L'+ IntToStr((Components[i]as TSudoCase).Ligne)+' C'+ IntToStr(Colonne) + ' reoit le : '+ IntToStr(Chiffre));
    end;
  end;// end du for

  // ********* Suppression des candidats des autres composants  ********/
  For I := 0 to ComponentCount-1 do
  If Components[I] is TSudoCase then
  begin
   // suppression des candidats pour la region
   IF (Components[i]as TSudoCase).region = CurrentRegion then
    (Components[i]as TSudoCase).ClearCandidat(Chiffre);
   // suppression des candidats pour la ligne
   IF (Components[i]as TSudoCase).Ligne = Ligne then
    (Components[i]as TSudoCase).ClearCandidat(Chiffre);
   // suppression des candidats pour la Colonne
   IF (Components[i]as TSudoCase).Colonne = Colonne then
    (Components[i]as TSudoCase).ClearCandidat(Chiffre);
  end;
  compteRestant;
End;
procedure TFramefille.TabSheet1MouseEnter(Sender: TObject);
begin
Screen.Cursor := crDefault;
end;

procedure TFramefille.TimerPartieTimer(Sender: TObject);
begin
//******************************************************
// Gestion du timer d'une partie
//******************************************************
 IF modeCourant= 'S' then exit;
 Inc(DureePartie);
 LabelTimer.Caption := DMFonction.SecondeToTemps(DureePartie); Exit;
end;

procedure TFramefille.ToutRejouer;
//*********************************************************************
// Effacela grille puis rejoue les coups enregistrs dans le recorder
//*********************************************************************
Var
 I : Integer;
begin
 MemoTrace.Clear;
 // *******  Commencer par tout effacer ********//
 For i := 0 to ComponentCount-1 do   // pour chaque composant
  If Components[i] is TSudoCase then // de type TsudoCase
   (Components[i]as TSudoCase).Vider; //effacer

 // *******  rejouer tout les coups  *******//
 For i := 0 to  PositionRecorder do
 begin
  IF recorder[i].Operation = 'S' then // si mode Saisie;
   mode('S',False);  // passer en mode Saisie;
  IF recorder[i].Operation = 'R' then // si mode Rsolution
   Mode('R',False);  // passer en mode Rsolution;
  IF Pos(recorder[i].Operation,'PC') > 0 then  // Si opration = P ( Poser un chiffre) OU C (supprimer un candidat)
   JouerCoup(recorder[i].Ligne,recorder[i].colonne,recorder[i].Chiffre, recorder[i].Operation);
 end;
end;
procedure TFramefille.Mode(Mode : String; Enregistrer : Boolean);
//*****************************
// passage en Mode S ou R
//*****************************
begin
 ModeCourant := Mode; // Soit R Soit S;
 // enregistrer le passage en mode R ou S  dans le recorder
 If Enregistrer then
 Begin
  Inc(PositionRecorder);
  Recorder[PositionRecorder].Ligne   := 0;
  Recorder[PositionRecorder].Colonne := 0;
  Recorder[PositionRecorder].Chiffre := 0;
  Recorder[PositionRecorder].Operation := Mode;
 end;
 If ModeCourant = 'S' then
 Begin
  MemoTrace.Clear;
  LabelTimer.Caption  := HeureVide;
  DureePartie         := 0;
  GBMode.Visible      := True;
  BT_EFF_TOUT.Visible := True;
  BT_REFAIRE.Visible  := False;
  TimerPartie.Enabled := False;
  ViderAnalyses;
 end
 Else
 Begin
  GBMode.Visible      := False;
  DureePartie := 0;
  TimerPartie.Enabled := True;
  BT_EFF_TOUT.Visible := False;
  BT_REFAIRE.Visible  := True;
 End;
end;
procedure TFramefille.JouerPreference;
//******************************//
//  Activation des preferences //
//****************************//
begin
 /////**** Candidats**********//
 IF DMFonction.CandidatsOnOff then
  SB_CandidatOnClick(SB_CandidatOn)
 Else
  SB_CandidatOnClick(SB_CandidatOff);

  /////**** Protection**********//
 IF DMFonction.ProtectionOnOff then
  SB_ProtectionOnClick(SB_ProtectionOn)
 Else
  SB_ProtectionOnClick(SB_ProtectionOff);
end;
function  TFramefille.GetChanged: Boolean;
//****************************************************
// Renvoi vrai si le fichier a t modifi
//****************************************************
begin
 GetChanged := Ischanged;
end;
procedure TFramefille.SetChanged(Change : Boolean);
//****************************************************
// Fixe Ischanged a vrai  ou faux et met a jour le Gift
// et la barre d'etat
//****************************************************
begin
 If IsChanged = Change then Exit;
 IsChanged := Change;
 If IsChanged then
  Save2DiskImg.BringToFront
 Else
  Save2DiskDisabledImg.BringToFront;
 LbStatus.Caption:= CheminCourant;
end;
procedure TFramefille.StringGridDblClick(Sender: TObject);
Var
 J :Integer;
 LaFamille,LeGroupe :ShortInt;
Begin
 If  StringGrid.Cells[0,0] = '' then Exit;
 LaFamille := StrToInt(StringGrid.Cells[3,StringGrid.Row]);
 LeGroupe  := StrToInt(StringGrid.Cells[4,StringGrid.Row]);
 MemoTrace.Lines.Add(StringGrid.Cells[0,StringGrid.Row]);
 for J := 1 to PCDec do
 begin
  IF (ListeDecouvertes[J].Famille = LaFamille) and (ListeDecouvertes[J].Groupe = LeGroupe) and (ListeDecouvertes[J].Operation <> 'V') then
  begin
   JouerCoup(ListeDecouvertes[J].Ligne,ListeDecouvertes[J].Colonne, StrTOInt(ListeDecouvertes[J].Candidat),ListeDecouvertes[J].Operation);
   // ecrire dans le recorder
   Inc(PositionRecorder);
   Recorder[PositionRecorder].Ligne     := ListeDecouvertes[J].Ligne;
   Recorder[PositionRecorder].Colonne   := ListeDecouvertes[J].Colonne;
   Recorder[PositionRecorder].Chiffre   := StrToInt(ListeDecouvertes[J].Candidat);
   Recorder[PositionRecorder].Operation := ListeDecouvertes[J].Operation;
   SetChanged(True); // il faudra sauvegarder
  end;
 end;
 sleep(200);
 ViderAnalyses;
 analyser;
 CheckListFamille.ItemIndex := LaFamille;
 CheckListFamilleClick(Self);

end;
Procedure TFramefille.StringGridMouseDown(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
var
 I,J : Integer;
 LaFamille,LeGroupe :ShortInt;
Begin
 If  StringGrid.Cells[0,0] = '' then Exit;
 LaFamille := StrToInt(StringGrid.Cells[3,StringGrid.Row]);
 LeGroupe  := StrToInt(StringGrid.Cells[4,StringGrid.Row]);
 For J := 0 to PCDec do
  IF (ListeDecouvertes[J].Famille = LaFamille) and (ListeDecouvertes[J].Groupe = LeGroupe) then
   For i := 0 to ComponentCount-1 do
    If Components[i] is TSudoCase then
     IF(Components[i]as TSudoCase).Ligne    = ListeDecouvertes[J].Ligne then
      IF(Components[i]as TSudoCase).Colonne  = ListeDecouvertes[J].Colonne then
       If ListeDecouvertes[J].Operation ='V' then
         (Components[i]as TSudoCase).CouleurFond := DMFonction.CouleurReference
        else
         (Components[i]as TSudoCase).CouleurFond := DMFonction.CouleurJouable;
end;
procedure TFramefille.StringGridMouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
Var
 i : Integer;
begin
 For i := 0 to ComponentCount-1 do
  If Components[i] is TSudoCase then
   (Components[i]as TSudoCase).CouleurFond := CLWhite;
end;
procedure TFramefille.CheckListFamilleClick(Sender: TObject);
Var
 I : Byte;
begin
 NettoyerStringGrid;
 For I := 1 to PCDec do
  IF (ListeDecouvertes[I].Famille = CheckListFamille.ItemIndex) and (ListeDecouvertes[I].Vue = 'O') then
  Begin
   StringGrid.Cells[0,Pred(StringGrid.RowCount)] := ListeDecouvertes[I].Texte;
   StringGrid.Cells[1,Pred(StringGrid.RowCount)] := IntToStr(ListeDecouvertes[I].Ligne);
   StringGrid.Cells[2,Pred(StringGrid.RowCount)] := IntToStr(ListeDecouvertes[I].Colonne);
   StringGrid.Cells[3,Pred(StringGrid.RowCount)] := IntToStr(ListeDecouvertes[I].Famille);
   StringGrid.Cells[4,Pred(StringGrid.RowCount)] := IntToStr(ListeDecouvertes[I].Groupe);
   StringGrid.Cells[5,Pred(StringGrid.RowCount)] := ListeDecouvertes[I].Operation;
   StringGrid.RowCount := StringGrid.RowCount+1;
  End;
  StringGrid.RowCount:= StringGrid.RowCount -1;
end;
procedure TFramefille.CheckListFamilleClickCheck(Sender: TObject);
begin
 If modecourant = 'R' then
   Analyser;
end;
procedure TFramefille.SaveToFile;
//***********************************************************
// enregistrer sur disque
//***********************************************************

Var
 I       : Integer;
 Fichier : TStringList;
 LeTexte : String;
begin
 Try
  Fichier := TStringList.Create;
  Fichier.Add('<?xml version="1.0" encoding="ISO-8859-1" ?>');
  Fichier.Add('<Actions>');

  // ajout d'un enregistrement dans le recorder qui
  // contient la duree actuelle de la partie
  // la dure sera insere dans la boucle plus bas
  Inc(PositionRecorder);
  Recorder[PositionRecorder].Ligne   := 0;
  Recorder[PositionRecorder].Colonne := 0;
  Recorder[PositionRecorder].Chiffre := 0;
  Recorder[PositionRecorder].Operation := 'T';

  For I := 0 to PositionRecorder do
  begin
   // si pose d'un chiffre
   If recorder[I].Operation = 'P' then
   Begin
     LeTexte := 'Ligne: '+ IntToStr(recorder[I].ligne)
     +' Colonne: '+IntTostr(recorder[I].Colonne)
     +' Mise en place du : '+ IntTostr(recorder[I].Chiffre);
   end;
   // si suppression d'un candidat
   If recorder[I].Operation = 'C' then
   Begin
     LeTexte := 'Ligne: '+ IntToStr(recorder[I].ligne)
     +' Colonne: '+IntTostr(recorder[I].Colonne)
     +' suppression du candidat : '+ IntTostr(recorder[I].Chiffre);
   end;

   // si Passage en mode rsolation
   If recorder[I].Operation = 'R' then
   Begin
     LeTexte := 'Ligne: '+ IntToStr(recorder[I].ligne)
     +' Colonne: '+IntTostr(recorder[I].Colonne)
     +' Passage en mode rsolution : '+ IntTostr(recorder[I].Chiffre);
   end;

   // si Passage en mode saisie
   If recorder[I].Operation = 'S' then
   Begin
     LeTexte := 'Ligne: '+ IntToStr(recorder[I].ligne)
     +' Colonne: '+IntTostr(recorder[I].Colonne)
     +' Passage en mode Saisie : '+ IntTostr(recorder[I].Chiffre);
   end;

   // si CODE T enregistrement du timer
   If recorder[I].Operation = 'T' then
     LeTexte := IntToStr(DureePartie)+ '# duree de la partie en secondes';

   fichier.Add('  <Action '
   +' Ligne = '+Quote+IntToSTR(recorder[I].ligne)+Quote
   +' Colonne ='+Quote+IntToSTR(recorder[I].Colonne)+Quote
   +' Chiffre = '+Quote+IntToSTR(recorder[I].Chiffre)+Quote
   +' Operation = '+Quote+recorder[I].Operation+Quote+'>'
   +LeTexte
   +'</Action>');
  end;
  Fichier.Add('</Actions>');
  Fichier.SaveToFile(CheminCourant);
 Finally
  Fichier.Free;
  SetChanged(False); // le sudoko n'a pas t modifi
  FormMain.SetStatusCaption(DMFonction.GetTranslatedMessage('Le fichier %s a t enregistr avec succs.', 22, CheminCourant));
  //Ajouter  la liste des fichiers recents
  DMFonction.AddFileToRecentFilesList(CheminCourant);
 End;
end;
procedure TFramefille.SB_CandidatOnClick(Sender: TObject);
Var
 I: Integer;
begin
 SB_CandidatOn.down := Boolean((sender as TSpeedButton).Tag);
 For i := 0 to ComponentCount-1 do
  If Components[i] is TSudoCase then
    (Components[i]as TSudoCase).ViewCandidat := Boolean((sender As TSpeedButton).Tag) ;
end;
procedure TFramefille.SB_ProtectionOnClick(Sender: TObject);
begin
 SB_ProtectionOn.down := Boolean((sender as TSpeedButton).Tag);
end;
procedure TFramefille.Label4Click(Sender: TObject);
begin
 DMFonction.AppelBrowser((Sender as TLabel).caption) ;
end;

procedure TFramefille.Label5Click(Sender: TObject);
Var
 Buffer : array[0..255] of Char;
begin
 ShellExecute(ValidParentForm(Self).Handle, 'open',
  StrPCopy(Buffer,'mailto:'+'p.fonten@free.fr'), nil, nil, SW_SHOW);
end;

procedure TFramefille.Label5MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
Screen.Cursor := crHandPoint;
end;

procedure TFramefille.LoadFromFile;
//*****************************************
// Charge le fichier
//*****************************************
Var
  I            : Integer;
  DureePartieTempo : Integer;
  Txt          : String;
  ChaineTempo  : String;
  Fichier      : TStringList;
begin
 PositionRecorder := -1;
 Try
  Fichier := TStringList.Create;
  Fichier.LoadFromFile(CheminCourant);

  For I := 0 to Fichier.Count-1 do
  begin
   Txt := Fichier[I];
   If copy(Txt,1,2) = '  ' then
   begin
    Inc(PositionRecorder);
    Recorder[PositionRecorder].Ligne     := StrToInt(Copy(Txt,21,1));
    Recorder[PositionRecorder].Colonne   := StrToInt(Copy(Txt,34,1));
    Recorder[PositionRecorder].Chiffre   := StrToInt(Copy(Txt,48,1));
    Recorder[PositionRecorder].Operation := Copy(Txt,64,1);
    ChaineTempo := Copy(Txt,67,20); //recupere les 20 premiers caracteres de la donne XML
   end;
  end;
  //lecture de la dure de la partie dans le dernier enregistrement
  If Recorder[PositionRecorder].Operation = 'T' then
  Begin
   DureePartieTempo := StrToInt(Copy(ChaineTempo,1,pos('#',ChaineTempo)-1));
   TimerPartie.Enabled := True;
   dec(PositionRecorder);
  End;
  ToutRejouer;
  DureePartie := DureePartieTempo;
  Analyser;
  JouerPreference;
  //**********************************

  Finally
  Fichier.Free;
  SetChanged(False); // le plateau n'a pas encore t modifi
 End;
end;
Procedure TFramefille.MettreCouleurCandidat;
//****************************************************
// Redessine les candidats dans la couleur demande
//****************************************************
Var
 i : Integer;
begin
 For i := 0 to ComponentCount-1 do
  If Components[i] is TSudoCase then
    (Components[i]as TSudoCase).CouleurCandidat := DMFonction.CouleurCandidat;
end;

Function  TFramefille.compteRestant(): Integer;
//********************************************************
// en profite pour compter les cases restant a trouver
//********************************************************

Var
 I : Integer ;
begin
 Result := 0;
 For i := 0 to ComponentCount-1 do
  If Components[i] is TSudoCase then
   If (Components[i]as TSudoCase).Number <> '' then
    inc(Result);                               { TODO : traduire }
 LabelCases.Caption := IntToStr(Result)+ '/81 cases';
end;
function  TFramefille.fermer(): Boolean;
var
 Retour : TModalResult;
begin
 Result := True; // On peut quitter
 if GetChanged then
 begin
  if SysUtils.Win32MajorVersion >= 6 then
  Begin
   TaskDialogSave.text := 'La grille '''+ CheminCourant +'''  t modifie depuis sa cration ou son chargement';
   TaskDialogSave.Execute;
   if TaskDialogSave.ModalResult = 100 then //sauver
    FormMain.ActionEnregistrerExecute(Self);
   if TaskDialogSave.ModalResult = MrCancel then //ne pas quitter
    Result := False;
  End
  else
  begin
   Retour := MessageDlg('Voulez-vous enregistrer la grille ?',mtConfirmation,[MbYes,MbNo,mbCancel],0);
   if Retour = mrYes then
    FormMain.ActionEnregistrerExecute(Self);
   if Retour = mrCancel then
     Result := False;
  end;
 end;
end;

       // *************************************************************//
       // ************* Routines Analyse de la rsolution *************//
       // *************************************************************//

procedure TFramefille.ViderAnalyses;
Var
 I : Integer;
begin                                                { TODO : traduire }
 CheckListFamille.Items.Strings[0] := '0 Candidat seul dans leur case';
 CheckListFamille.Items.Strings[1] := '0 Candidat seul dans une unit L/C ou rgion';
 CheckListFamille.Items.Strings[2] := '0 jumeaux/tripls decouvert';
 CheckListFamille.Items.Strings[3] := '0 Inter action L/C avec rgion';
 CheckListFamille.Items.Strings[4] := '0 configuration franche';
 CheckListFamille.Items.Strings[5] := '0 configuration exclusive';


 For I := 0 To NbFamille-1 do
  CheckListFamille.Checked[I] := False;
 NettoyerStringGrid;
 ViderListeDecouvertes(listedecouvertes,PcDec);
end;
procedure TFramefille.Analyser;
//*******************************************************
// Analyse de la grille a chaque coup jou + resolution
// eventuel des decouvertes en fonction des cases coches
//********************************************************

begin
 NettoyerStringGrid;
 ViderListeDecouvertes(listedecouvertes,PcDec);
 IF compteRestant = 81 then
 begin
  TimerPartie.Enabled := False;
  ViderAnalyses;
  Exit;
 end;
 SudokuToGrille; // mise en RECORD de la grille actuelle (mthode commune)

  //************************************************** //
 //************* appels des methodes     ************ //
 //************************************************** //
                                                     { TODO : traduire }
 // Famille 0 -  candidats seuls dans leur cases
 CandidatSeulDansCase(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle);
 CheckListFamille.Items.Strings[0] := IntToStr(NbDeDecouverte)+ ' Candidat(s) seul(s) dans leur case';

 // Famille 1 -  candidats seuls sur la ligne colonne region
 NbDeDecouverte := 0;
 CandidatPresentUneFois(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'L');
 CandidatPresentUneFois(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'C');
 CandidatPresentUneFois(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'R');
 CheckListFamille.Items.Strings[1] := IntToStr(NbDeDecouverte)+ ' Candidat(s) seul(s) dans une unit L/C ou R';

 // Famille 2 -  Jumeaux et tripls
 NbDeDecouverte := 0;
 JumeauxTriplesLignes(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle);
 JumeauxTriplesColonnes(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle);
 CheckListFamille.Items.Strings[2] := IntToStr(NbDeDecouverte)+ ' Jumeaux/Tripls dcouvert(s)';

 // Famille 3 -  Inter Actions L/C et region
 NbDeDecouverte := 0;
 InterActionlignesRegion(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle);
 InterActionColonnesRegion(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle);
 CheckListFamille.Items.Strings[3] := IntToStr(NbDeDecouverte)+ ' interaction L/C et regions dcouvert(s)';

 // Famille 4 -  le paires/ triples/ quad /francs
 NbDeDecouverte := 0;
 ConfigurationsFranches(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,2,'L',' en doublet franc sur ');
 ConfigurationsFranches(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,2,'C',' en doublet franc sur ');
 ConfigurationsFranches(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,2,'R',' en doublet franc sur ');
 ConfigurationsFranches(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,3,'L',' en triplet franc sur ');
 ConfigurationsFranches(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,3,'C',' en triplet franc sur ');
 ConfigurationsFranches(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,3,'R',' en triplet franc sur ');
 TriosExclusifsIncomplets(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'L');
 TriosExclusifsIncomplets(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'C');
 TriosExclusifsIncomplets(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'R');
 ConfigurationsFranches(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,4,'L',' en quadruplet franc sur ');
 ConfigurationsFranches(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,4,'C',' en quadruplet franc sur ');
 ConfigurationsFranches(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,4,'R',' en quadruplet franc sur ');
 CheckListFamille.Items.Strings[4] := IntToStr(NbDeDecouverte)+ ' Configuration(s) franche(s)dcouverte(s)';

 // Famille 5 -  Configuration  Exclusives doublets et triples
 NbDeDecouverte := 0;
 DoubletsExlusifs(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'L');
 DoubletsExlusifs(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'C');
 DoubletsExlusifs(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'R');
 TripletsExlusifs(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'L');
 TripletsExlusifs(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'C');
 TripletsExlusifs(listedecouvertes,PcDec,NbDeDecouverte,GrilleActuelle,'R');
 CheckListFamille.Items.Strings[5] := IntToStr(NbDeDecouverte)+ ' configuration exclusive(s) dcouverte(s)';
 






 // refaire ICI les autres analyses et recherche avec le mme canevas
 JouerAnalyse();
end;
procedure TFramefille.BtJouerClick(Sender: TObject);
begin
  Mode('R',True);
  Analyser;
end;
procedure TFramefille.BT_EFF_TOUTClick(Sender: TObject);
Var
 I : Integer;
begin                          { TODO : traduire }
If MessageDlg('Confirmez l''effacement total de la grille ?',mtConfirmation,[MbYes,MbNo],0) = MrNo then Exit;
 For i := 0 to ComponentCount-1 do   // pour chaque composant
  If Components[i] is TSudoCase then // de type TsudoCase
   (Components[i]as TSudoCase).Vider; //effacer
 PositionRecorder := -1;  // mettre la position courante a -1
 mode('S',True);
end;
procedure TFramefille.Bt_PRECEDENTClick(Sender: TObject);
Var
 TempsTempo : Integer;
begin
 // on recule pas si on est a zero
 If PositionRecorder = -1 then exit;
 Dec(PositionRecorder);
 If Recorder[PositionRecorder].Operation = 'R' then
  dec(PositionRecorder);
 TempsTempo := DureePartie;
 ToutRejouer;
 DureePartie := TempsTempo;
 If ModeCourant = 'R' then
  Analyser;
 SetChanged(true);
end;
procedure TFramefille.BT_REFAIREClick(Sender: TObject);
Var
 I : Integer;
begin                        { TODO : traduire }
 If MessageDlg('Recommencez la grille ?',mtConfirmation,[MbYes,MbNo],0) = MrNo then Exit;
 MemoTrace.Clear;
 For i := 0 to ComponentCount-1 do
  If Components[i] is TSudoCase then
   (Components[i]as TSudoCase).vider;
 // rejouer tant que l'on ne passe pas en mode 'R'
 I := -1;
 repeat
  Inc(I);
  IF recorder[i].Operation = 'S' then
   Mode('S',False);  // passer en mode Saisie;

  IF recorder[i].Operation = 'R' then
   Mode('R',False);  // passer en mode Saisie;

  IF recorder[i].Operation = 'P' then
   JouerCoup(recorder[i].Ligne,recorder[i].colonne,recorder[i].Chiffre, recorder[i].Operation);

 Until Recorder[i].Operation = 'R';
 PositionRecorder := i;
 Analyser;

end;
procedure TFramefille.NettoyerStringGrid;
begin
 // preparer la grille
 StringGrid.RowCount     := 1;
 StringGrid.Rows[0].Text := '';
 StringGrid.ColCount     := 6;
 StringGrid.ColWidths[0] := 377;
 StringGrid.ColWidths[1] := 0;
 StringGrid.ColWidths[2] := 0;
 StringGrid.ColWidths[3] := 0;
 StringGrid.ColWidths[4] := 0;
 StringGrid.ColWidths[5] := 0;
End;
procedure TFramefille.JouerAnalyse();
Var
 I : Integer;
 RefaireAnalyse : Boolean;
begin
 RefaireAnalyse := False;
 For I := 0 to Nbfamille-1 do
  If CheckListFamille.Checked[I] then // si la case est coche
   If  JouerFamille(I) then // jouer la famille ;
    RefaireAnalyse := True;
 IF compteRestant = 81 then ViderAnalyses;
 If RefaireAnalyse then Analyser;
end;
Function TFramefille.JouerFamille(Famille : ShortInt):Boolean;
Var
 J :Integer;
begin
 Result := False;
 for J := 1 to PCDec do
 begin
  If  (ListeDecouvertes[J].Vue ='O')and (ListeDecouvertes[J].Famille = Famille) then
   MemoTrace.Lines.Add(ListeDecouvertes[J].Texte);
  IF (ListeDecouvertes[J].Famille = Famille) and(ListeDecouvertes[J].Operation <>'V' ) then
  begin
   JouerCoup(ListeDecouvertes[J].Ligne,ListeDecouvertes[J].Colonne, StrTOInt(ListeDecouvertes[J].Candidat),ListeDecouvertes[J].Operation);
   // ecrire dans le recorder
   Inc(PositionRecorder);
   Recorder[PositionRecorder].Ligne     := ListeDecouvertes[J].Ligne;
   Recorder[PositionRecorder].Colonne   := ListeDecouvertes[J].Colonne;
   Recorder[PositionRecorder].Chiffre   := StrToInt(ListeDecouvertes[J].Candidat);
   Recorder[PositionRecorder].Operation := ListeDecouvertes[J].Operation;
   SetChanged(True); // il faudra sauvegarder
   Result := True;   // il y a eu au moins une action
  end;
 End;
end;
procedure TFramefille.SudokuToGrille;
//********************************************************************
// charge toute les infos connues du sudoku courant dans une grille
// la grille sera passe en parametre aux routines de recherche
//********************************************************************

Var
 i,PosteCourant  : Integer;
begin
 PosteCourant := 1;
 For i := 0 to ComponentCount-1 do
  If Components[i] is TSudoCase then
  begin
   grilleActuelle[PosteCourant].Ligne   := StrToInt((Components[i]as TSudoCase).Name[2]);
   grilleActuelle[PosteCourant].Colonne := StrToInt((Components[i]as TSudoCase).Name[4]);
   grilleActuelle[PosteCourant].Region  := StrToInt((Components[i]as TSudoCase).Name[6]);
   grilleActuelle[PosteCourant].Valeur  := (Components[i]as TSudoCase).Number;
   grilleActuelle[PosteCourant].Cand    := (Components[i]as TSudoCase).RenvoiCandidats;
   grilleActuelle[PosteCourant].ligReg  := PlaceEnregion(grilleActuelle[PosteCourant].Ligne); // 1 2 ou 3 me ligne de la region
   grilleActuelle[PosteCourant].ColReg  := PlaceEnregion(grilleActuelle[PosteCourant].Colonne); // 1 2 ou 3 me Colonne de la region
   Inc(PosteCourant);
  End;
end;
procedure TFramefille.ChaineToGrille(Chaine : String);
//*************************************
// Routine proprement dite de copie
// dans la grille courante
//*************************************
Var
I,Lig,Col : Integer;
Ch : String[1];
ChOffset : String[1];
begin
 If Length(trim(Chaine)) <> 81 then
 begin                                                 { TODO : traduire }
  MessageDlg('Sudoku non rcuparable,81 Caractres attendus',mtInformation,[MbOk],0);
  exit;
 end;
 I := 0;
 Repeat
  Inc(i);
  Ch := Chaine[i];
 Until Pos(Chaine[i],'123456789') = 0 ;
 //ici ch contient de caractere qui definit la case vide soit . soit 0 soit autre

 For Lig := 1 to 9 do
  For Col := 1 TO 9 Do
  Begin
   ChOffset := Chaine[((lig-1)*9)+Col];
   If ChOffset<>Ch then
   begin
    Inc(PositionRecorder);
    JouerCoup(Lig,Col,StrToInt(ChOffset),'P');
    Recorder[PositionRecorder].Ligne   := Lig;
    Recorder[PositionRecorder].Colonne := Col;
    Recorder[PositionRecorder].Chiffre := StrToInt(ChOffset);
    Recorder[PositionRecorder].Operation := 'P';
   End;
  End;
end;

        //******************************************************
        // Routnines d'impression d'une fiche de sudoku
        //******************************************************

procedure TFramefille.Imprimer;
//******************************************************
// Gestion de l'impression d'une fiche
//******************************************************
Var
 I : Integer;
begin
 // appel de l'ecran de parametrage d'impression
 If PrintDialog1.Execute then
 begin
  initialiseImprimante;
  Printer.BeginDoc;
  DessinGrille;
 For i := 0 to ComponentCount-1 do
  If Components[i] is TSudoCase then
    IF (Components[i]as TSudoCase).Number = '' then // impression de candidats
    Begin
     If SB_CandidatOn.Down then // impression des candidats seulement si voir est actif
      DessinCandidats((Components[i]as TSudoCase).Ligne,(Components[i]as TSudoCase).Colonne,(Components[i]as TSudoCase).RenvoiCandidats);
    End
    Else
    Begin
      DessinChiffre((Components[i]as TSudoCase).Ligne,(Components[i]as TSudoCase).Colonne,(Components[i]as TSudoCase).Number);
    End;
  Printer.EndDoc;
 end;
end;
Procedure TFramefille.ImprimerJuste(LeX : integer ; LeY : integer; LeChiffre :String);
//***************************************************
//  imprimer un chiffre sur le papier
//***************************************************

var
  X,Y : Integer;
begin
 X := Round((LeX-MargeGauche) * CoeffX);
 Y := Round((LeY -MargeHaute) * CoeffY);
 Printer.Canvas.TextOut(X,Y,LeChiffre);
end;
procedure TFramefille.initialiseImprimante;
//***************************************************
// preparation de l'imprimante
//***************************************************

begin
 CoeffX      := printer.PageWidth  / (GetDeviceCaps(printer.Handle,HORZSIZE)*10);
 CoeffY      := printer.PageHeight / (GetDeviceCaps(printer.Handle,VERTSIZE)*10);
 MargeHaute    := GetDeviceCaps(printer.Handle,PHYSICALOFFSETY);
 MargeGauche   := GetDeviceCaps(printer.Handle,PHYSICALOFFSETX);
 OffsetGauche  := 510;
 OffsetHaut    := 300;      { TODO : traduire }
 Printer.Title := 'Impression '+ DMFonction.ProgName; Printer.Orientation   := poPortrait; // sens vertical de la feuille
 Printer.Canvas.Font.Color  := ClBlack; // toujours du Noir
 Printer.Canvas.Pen.Color   := ClBlack; // pour les chiffres et les traits
 Printer.Canvas.Brush.Style := BsClear; // mode transparent
end;
procedure TFramefille.DessinChiffre(Ligne,Colonne : Integer; Chiffre : String);
//**********************************************
// Procedure de dessin d'un chiffre dans la grille
//**********************************************
begin
 SelectionFonte('Times New Roman',22,[]);
 ImprimerJuste(OffsetGauche+((colonne-1)*120)+40,OffsetHaut+((ligne-1)*120)+15,Chiffre);
end;
procedure TFramefille.DessinCandidats(Ligne,Colonne : Integer; TabCand : String);
//**********************************************
// Procedure de dessin des candidats
//**********************************************
begin
 SelectionFonte('Times New Roman',8,[]);
 If pos('1',TabCand)>0 then
  ImprimerJuste(OffsetGauche+((colonne-1)*120)+10,OffsetHaut+((ligne-1)*120)+3,'1');
 If pos('2',TabCand)>0 then
  ImprimerJuste(OffsetGauche+((colonne-1)*120)+50,OffsetHaut+((ligne-1)*120)+3,'2');
 If pos('3',TabCand)>0 then
  ImprimerJuste(OffsetGauche+((colonne-1)*120)+90,OffsetHaut+((ligne-1)*120)+3,'3');
 If pos('4',TabCand)>0 then
  ImprimerJuste(OffsetGauche+((colonne-1)*120)+10,OffsetHaut+((ligne-1)*120)+43,'4');
 If pos('5',TabCand)>0 then
  ImprimerJuste(OffsetGauche+((colonne-1)*120)+50,OffsetHaut+((ligne-1)*120)+43,'5');
 If pos('6',TabCand)>0 then
  ImprimerJuste(OffsetGauche+((colonne-1)*120)+90,OffsetHaut+((ligne-1)*120)+43,'6');
 If pos('7',TabCand)>0 then
  ImprimerJuste(OffsetGauche+((colonne-1)*120)+10,OffsetHaut+((ligne-1)*120)+83,'7');
 If pos('8',TabCand)>0 then
  ImprimerJuste(OffsetGauche+((colonne-1)*120)+50,OffsetHaut+((ligne-1)*120)+83,'8');
 If pos('9',TabCand)>0 then
  ImprimerJuste(OffsetGauche+((colonne-1)*120)+90,OffsetHaut+((ligne-1)*120)+83,'9');
end;
procedure TFramefille.DessinGrille;
//**********************************************
// Porcedure de dessin de la grille vide
//**********************************************

Var
 I,EpaisseurTrait: Integer;
begin
 For I := 0 to 9 do
 Begin
 IF i mod 3 = 0 then EpaisseurTrait := 6 else EpaisseurTrait := 1;
 ImprimerTrait(OffsetGauche,OffsetHaut+I*120,120*9,EpaisseurTrait,'H');
 ImprimerTrait(OffsetGauche+I*120,OffsetHaut,120*9,EpaisseurTrait,'V');
 End;
end;
Procedure TFramefille.ImprimerTrait(LeX , leY ,Longueur,Epaisseur: integer; Sens : String);
//*************************************************
// Impression d'un trait Vertical ou horizontal
//*************************************************
var
  X,Y,L : Integer;
begin
 X := Round((LeX-MargeGauche) * CoeffX);
 Y := Round((LeY-MargeHaute)  * CoeffY);
 Printer.Canvas.Pen.Color := ClBlack;
 Printer.Canvas.Pen.Width := Epaisseur;

 If Sens = 'V' then
 begin

  L  := Round(Longueur * CoeffY);
  Printer.Canvas.moveTo(X,Y);
  Printer.Canvas.LineTo(X,Y+L);
 end
 else
 begin
  L  :=  Round(Longueur * CoeffX);
  Printer.Canvas.moveTo(X,Y);
  Printer.Canvas.LineTo(X+L,Y);
 end;
end;
procedure TFramefille.SelectionFonte(Name : String; size : Integer;FontStyle : TFontStyles );
//*************************************
// Precise les attributs de la fonte
// a utiliser
//*************************************
begin
 // Selection de la fonte
  Printer.Canvas.Font.Name := Name;
  Printer.Canvas.Font.Size := Size;
  Printer.Canvas.Font.Style := FontStyle;
end;
Procedure TFramefille.GRilleToPP;
//*************************************
// Copie le Sudoku courant dans le presse papier de Windows
//*************************************
Var
 Chaine : String[11];
 I,J,K : Integer ;
begin
 MemoClipboard.Clear;
 For I := 1 to 9 do // de la ligne 1  9
 Begin
  Chaine :='.........';
  For J := 0 to ComponentCount-1 do
  begin
   If Components[J] is TSudoCase then
    IF (Components[J]as TSudoCase).Number<>'' then
     IF (Components[J]as TSudoCase).Ligne = I then // pour la ligne
     Begin
      k:= (Components[J]as TSudoCase).Colonne;
      If k >3 then inc(K);
      If k >7 then Inc(K);
      Chaine[k]:= (Components[J]as TSudoCase).Number[1];
     end;
  End; // for J
  MemoClipboard.Lines.Add(chaine);
  If Pos(IntToStr(I),'36')>0 then
   MemoClipboard.Lines.Add('---+---+---');
 End;// for I
 MemoClipboard.SelectAll;
 MemoClipboard.CopyToClipboard;
end;
procedure TFramefille.PPToGrille;
//*************************************
// Copie le PP courant dans le Sudoku
//*************************************
Var
I,J : Integer;
Chaine : AnsiString;
ChaineCourante : AnsiString;
begin
 If compteRestant > 0 then // la grille doit tre vide
 begin                          { TODO : traduire }
  MessageDlg('La grille n''est pas vide',mtInformation,[mbOk],0);
  Exit;
 end;
 MemoClipboard.Clear;
 MemoClipboard.PasteFromClipboard;
 Chaine := '';
 IF MemoClipboard.Lines.Count = 1 then
  ChaineToGrille(MemoClipboard.Text)
 else
 Begin
  For I := 0 to MemoClipboard.Lines.Count-1 do
  Begin
   ChaineCourante := MemoClipboard.Lines[I];
   For J := 1 To Length(ChaineCourante) do
   Begin
    If Pos(ChaineCourante[J],'123456789 .') > 0 then
     Chaine := Chaine + ChaineCourante[J];
   End; // For J
  End;// For I
  //ici le sudoku est sur une ligne dans Chaine
  ChaineToGrille(Chaine);
 End;
end;


end.
