unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnCtrls, ToolWin, ActnMan, ActnMenus, StdActns, ActnList,
  XPStyleActnCtrls, StdCtrls, ImgList, ComCtrls, Menus,inifiles, ExtActns,
  ExtCtrls,UDmFonction, XPMan, ActnColorMaps, PageExtControl,Jpeg;

type
  TFormMain = class(TForm)
    ActionManager1: TActionManager;
    ImageListN: TImageList;
    ImageListD: TImageList;
    ToolBarMain: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ImageListPt: TImageList;
    ActionNouveau: TAction;
    EditCopier: TEditCopy;
    EditColler: TEditPaste;
    ActionOuvrir: TAction;
    ActionEnregistrer: TAction;
    ActionEnregSous: TAction;
    ActionImprime: TAction;
    ActionQuitter: TAction;
    ActionAide: TAction;
    ActionAPropos: TAction;
    ActionConfig: TAction;
    MainMenu: TMainMenu;
    Menu_Fichier: TMenuItem;
    Nouveau1: TMenuItem;
    Ouvrir1: TMenuItem;
    Enregistrer1: TMenuItem;
    EnregistrerSous1: TMenuItem;
    Configurer1: TMenuItem;
    Quitter1: TMenuItem;
    Menu_Edition: TMenuItem;
    Dupliquer: TMenuItem;
    N3: TMenuItem;
    Menu_aide: TMenuItem;
    Aideduprogramme1: TMenuItem;
    AProposde1: TMenuItem;
    StatusBar: TStatusBar;
    Langues: TMenuItem;
    Astuce: TMenuItem;
    ActionAstuce: TAction;
    N4: TMenuItem;
    BrowseURL1: TBrowseURL;
    Menu_BarreOutils: TMenuItem;
    MenuSiteWeb: TMenuItem;
    OpenRecentMI: TMenuItem;
    N6: TMenuItem;
    MenuOutils: TMenuItem;
    MenuNouvelleVersion: TMenuItem;
    N9: TMenuItem;
    ToolButton14: TToolButton;
    XPManifest1: TXPManifest;
    ActionDupliquer: TAction;
    MenuColler: TMenuItem;
    MenuCopier: TMenuItem;
    ActionGrilleToJPG: TAction;
    GrilleversBMP1: TMenuItem;
    Imprimer1: TMenuItem;
    N12: TMenuItem;
    PageExtControl1: TPageExtControl;
    SaveDialogBmp: TSaveDialog;
    ImageJPG: TImage;
    TaskDialogNewGrid: TTaskDialog;
    ToolButton3: TToolButton;
    procedure ActionNouveauExecute(Sender: TObject);
    procedure ActionOuvrirExecute(Sender: TObject);
    procedure ActionEnregistrerExecute(Sender: TObject);
    procedure ActionImprimeExecute(Sender: TObject);
    procedure ActionQuitterExecute(Sender: TObject);
    procedure ActionAideExecute(Sender: TObject);
    procedure ActionConfigExecute(Sender: TObject);
    procedure ActionEnregSousExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionAProposExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LanguageChange(Sender: TObject);
    procedure ActionAstuceExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Menu_BarreOutilsClick(Sender: TObject);
    procedure OpenFile(fname: string);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure CreerItemMenu(Code, Clair : String);
    procedure CreerMenuLanguage;
    procedure ShowHint(Sender : tObject);
    procedure MajAction(Suppr : Boolean = False);
    procedure MenuNouvelleVersionClick(Sender: TObject);
    procedure ActionDupliquerExecute(Sender: TObject);
    procedure EditCopierExecute(Sender: TObject);
    procedure EditCollerExecute(Sender: TObject);
    procedure ActionGrilleToJPGExecute(Sender: TObject);
    procedure PageExtControl1TabClose(Sender: TObject; TabIndex: Integer;
      var CanClose: Boolean);
    procedure PageExtControl1TabDelete(Sender: TObject; TabIndex: Integer);
  private
    function NomAleat(Lg: Integer): String;
    function Aleatoire(Num1, Num2: integer): integer;
    { Dclarations prives }

  public
    { Dclarations publiques }
    RecorderTMP         : array [0..1000] of TActionSudoku; // prevoyons large
    PositionRecorderTMP : Integer;
    DureePartieTmp      : Integer;

   procedure SetStatusCaption(s: string);

  end;

var
  FormMain: TFormMain;

implementation

uses USplash, Tips, UConfig, UFrame, UcreerGrille;

{$R *.dfm}



//******************************************
// Cration d'une nouvelle fenetre fille
//******************************************
procedure TFormMain.ActionNouveauExecute(Sender: TObject);
var
  Retour       : TmodalResult;
  ChaineSudoku : String[81];
  NewTabs      : TTabExtSheet;
  NewFrame     : TFramefille;
begin
 if SysUtils.Win32MajorVersion >= 6 then
 Begin
  TaskDialogNewGrid.Execute;
  If TaskDialogNewGrid.ModalResult = mrCancel then
   Exit;
  // creation d'un onglet et de sa frame
  NewTabs := TTabExtSheet.Create(Self);
  with NewTabs do
  begin
   Name     := NomAleat(6);
   Caption  := NONAME+' '+DMFonction.GetNextNonameNumber+Space; //Initialise le nom
   Parent   := Self;
   PageExtControl := PageExtControl1;
   Colors.ActiveFill1 := ClWhite;
   Colors.ActiveFill2 := ClWhite;
   NewFrame := TFramefille.Create(NewTabs);
   NewFrame.Parent    := NewTabs;
   NewFrame.Align     := alClient;
   NewFrame.Name      := Name;
   NewFrame.CheminCourant := '';
   NewFrame.AvoirNom  := False;
   NewFrame.CreerPlateau;
  end;
  // si grille genre
  if TaskDialogNewGrid.ModalResult = 101 then
  begin
   ChaineSudoku := Generer;
   NewFrame.ChaineToGrille(ChaineSudoku);
   NewFrame.BtJouerClick(Self);
  end;
 end // du SysUtils.Win32MajorVersion
 else
 begin
  Retour := MessageDlg('Voulez-vous une grille gnre ?',mtConfirmation,[MbYes,MbNo,mbCancel],0);
  if Retour = mrCancel then Exit;
  // creation d'un onglet et de sa frame
  NewTabs := TTabExtSheet.Create(Self);
  with NewTabs do
  begin
   Name     := NomAleat(6);
   Caption  := NONAME+' '+DMFonction.GetNextNonameNumber+Space; //Initialise le nom
   Parent   := Self;
   PageExtControl := PageExtControl1;
   Colors.ActiveFill1 := ClWhite;
   Colors.ActiveFill2 := ClWhite;
   NewFrame := TFramefille.Create(NewTabs);
   NewFrame.Parent    := NewTabs;
   NewFrame.Align     := alClient;
   NewFrame.Name      := Name;
   NewFrame.CheminCourant := '';
   NewFrame.AvoirNom  := False;
   NewFrame.CreerPlateau;
  end;
  // si grille genre
  if Retour = mrYes then
  begin
   ChaineSudoku := Generer;
   NewFrame.ChaineToGrille(ChaineSudoku);
   NewFrame.BtJouerClick(Self);
  end;
 end;
 PageExtControl1.ActivePageIndex := NewTabs.TabIndex;
 MajAction; // mise  jour des actionList en fonction du contexte

end;

//******************************************
// Selection et validation du fichier a ouvrir
//******************************************
procedure TFormMain.ActionOuvrirExecute(Sender: TObject);
var
 theOpenDialog: TOpenDialog;
begin
 theOpenDialog:=TOpenDialog.Create(nil); // instanciation
 try
  theOpenDialog.Title:=DMFonction.GetTranslatedMessage('Ouvrir un fichier ...', 26);
  theOpenDialog.DefaultExt:=EXT;
  theOpenDialog.Filter:=DMFonction.GetTranslatedMessage('Fichiers XML', 24)+' (*.'+EXT+')|*.'+EXT;
  if(DirectoryExists(DMFonction.RecentOpenFileDir))then
   theOpenDialog.InitialDir:=DMFonction.RecentOpenFileDir
  else
   theOpenDialog.InitialDir:='';

  if(theOpenDialog.Execute)then // si Ok selectionn
  begin
   OpenFile(theOpenDialog.Filename); // ouverture proprement dite
   DMFonction.RecentOpenFileDir:=ExtractFilePath(theOpenDialog.Filename); // recup du chemin pour la prochaine fois
  end;
 finally
  theOpenDialog.Free;  // libration de la ressource
 end;
end;

//****************************************************
// Verif si fichier existe, maj des menus recents et
// fenetres appel de LoadFromFile pour le fichier
// dans la frame fille
//****************************************************
procedure TFormMain.OpenFile(fname: string);
var
 NewTabs      : TTabExtSheet;
 NewFrame     : TFramefille;
 i            : Integer;
begin
 if(Not(FileExists(fname)))then
  raise EInOutError.Create(DMFonction.GetTranslatedMessage('Fichier non trouv :', 27)+#13#10+fname);

 NewTabs := TTabExtSheet.Create(Self);
 with NewTabs do
 begin
  Name     := NomAleat(6);
  Parent   := Self;
  PageExtControl := PageExtControl1;
  Colors.ActiveFill1 := ClWhite;
  Colors.ActiveFill2 := ClWhite;
  Caption  :=   Copy(ExtractFileName(fname), 1, Length(ExtractFileName(fname))-Length(ExtractFileExt(fname)))+Space;
  NewFrame := TFramefille.Create(NewTabs);
  NewFrame.Name      := Name;
  NewFrame.Parent    := NewTabs;
  NewFrame.Align     := alClient;
  NewFrame.CreerPlateau;
  NewFrame.avoirnom := True;
  NewFrame.CheminCourant := fname;
  NewFrame.LoadFromFile;
 end;
 DMFonction.AddFileToRecentFilesList(fname);//Ajouter  la liste des fichiers recents
 MajAction; // mettre a jour les ActionList en fonction du contexte
 PageExtControl1.ActivePageIndex := NewTabs.TabIndex;
end;

procedure TFormMain.PageExtControl1TabClose(Sender: TObject; TabIndex: Integer;
  var CanClose: Boolean);
//****************************************************************
// Fermer une fenetre Fille
//****************************************************************
  Var
 LaFrame : TComponent;
begin
 // rehercher la frame correspondant  l'onglet
 LaFrame := PageExtControl1.Pages[TabIndex].FindComponent(PageExtControl1.Pages[TabIndex].Name);
 //Appel de fonction de fermeture
 CanClose := (LaFrame as TFramefille).fermer();
end;



procedure TFormMain.PageExtControl1TabDelete(Sender: TObject;
  TabIndex: Integer);
begin
 MajAction(True);
end;

//****************************************************
// Enregistrer le fichier
//****************************************************
procedure TFormMain.ActionEnregistrerExecute(Sender: TObject);
Var
 LaFrame : TComponent;
begin
 LaFrame := PageExtControl1.ActivePage.FindComponent(PageExtControl1.ActivePage.Name);
 if not (LaFrame as TFramefille).AvoirNom then  // appel de enregistrer sous car pas encore de nom pour le fichier de cette fenetre
  ActionEnregSousExecute(self)
  else
  (LaFrame as TFramefille).SaveToFile;  // appel de SaveToFile de cette fentre fille
end;


//****************************************************
// Imprimer
//****************************************************
procedure TFormMain.ActionImprimeExecute(Sender: TObject);
Var
 LaFrame : TComponent;
begin
 LaFrame := PageExtControl1.ActivePage.FindComponent(PageExtControl1.ActivePage.Name);
 (LaFrame as TFramefille).Imprimer;
end;

//****************************************************
// Action Quitter Un simple Close
// Attention appel intermediaire a onCloseQuery
//****************************************************
procedure TFormMain.ActionQuitterExecute(Sender: TObject);
begin
 close;
end;

//**********************************
// voulez vous quitter ?
//**********************************
procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 If DmFonction.QuitConfirm then
  If DMFonction.MessageLocalise('Voulez-vous vraiment quitter ?','','',18,mtConfirmation,[mbYes,MbNo],0) = MrNo then
   Action := CaNone;
end;

//*********************************************************************************
// avant d'appeler le CLose, on verifie les fenetres modifies devant tre sauves
//*********************************************************************************
procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
 i : Integer;
 LaFrame : TComponent;
begin
 For i := 0 to PageExtControl1.PageCount -1 do
 begin
  LaFrame := PageExtControl1.Pages[i].FindComponent(PageExtControl1.Pages[i].Name);
  IF not (LaFrame as TFramefille).fermer() then
  begin
   CanClose := False;
   exit;
  end;
 end;
end;

//*********************************************************************************
// Appel de l'aide on appel un URI avec :
// le nom du site -> "http://p.fonten.free.fr/"
// le nom de la page ->Principal "SudokuTrainer_"
// le code de la langue "DMFonction.LanguageCode" + .html
// ceci permet d'avoir des aides en ligne multilangues facilement
// il suffit de placer l'aide sur le NET
//*********************************************************************************
procedure TFormMain.ActionAideExecute(Sender: TObject);
begin
 DMFonction.AppelBrowser('http://p.fonten.free.fr/SudokuTrainer_'+DMFonction.LanguageCode+'.html') ;
end;


//**********************************************************************
// Gestion des parametres globaux de l'application
// Placez ici les parametres propes a l'application
//**********************************************************************
procedure TFormMain.ActionConfigExecute(Sender: TObject);
Var
 LaFrame : TComponent;
begin
 FrmConfig:=TFrmConfig.Create(self); // constructeur
 DMFonction.TranslateForm(FrmConfig); // choix de la langue
 FrmConfig.caption := DMFonction.GetTranslatedMessage('Configurer Sudoku Trainer',21);
 // charger l'ecran avec les valeurs
 FrmConfig.LbShowTipsOnStartup.Checked := DMFonction.ShowTipsOnStartup;
 FrmConfig.LbSavePosWin.Checked        := DMFonction.SavePosWin;
 FrmConfig.CbQuitConfirm.checked       := DMFonction.QuitConfirm;
 FrmConfig.UpDown1.Position            := DMFonction.TimeSplash;
 FrmConfig.CBReopenLastFile.Checked    := DMFonction.ReopenLastFile;
 FrmConfig.ShapeChiffre.Brush.Color    := DMFonction.CouleurChiffre;
 FrmConfig.ShapeDevoile.Brush.Color    := DMFonction.CouleurDevoile;
 FrmConfig.ShapeCandidat.Brush.Color   := DMFonction.CouleurCandidat;
 FrmConfig.ShapeJouable.Brush.Color    := DMFonction.CouleurJouable;
 FrmConfig.ShapeReference.Brush.Color  := DMFonction.CouleurReference;
 FrmConfig.CBCandidatsOnOff.Checked   := DMFonction.candidatsOnOff;
 FrmConfig.CBProtectionOnOFF.Checked  := DMFonction.ProtectionOnOff;


 If FrmConfig.ShowModal = MrOk then  //Affichage
 Begin
  // sauvegarder les valeurs
  DMFonction.ShowTipsOnStartup := FrmConfig.LbShowTipsOnStartup.Checked;
  DMFonction.SavePosWin        := FrmConfig.LbSavePosWin.Checked;
  DMFonction.TimeSplash        := FrmConfig.UpDown1.Position;
  DMFonction.QuitConfirm       := FrmConfig.CbquitConfirm.checked;
  DMFonction.ReopenLastFile    := FrmConfig.CBReopenLastFile.Checked;
  DMFonction.CouleurChiffre    := FrmConfig.ShapeChiffre.Brush.Color;
  DMFonction.CouleurDevoile    := FrmConfig.ShapeDevoile.Brush.Color;
  DMFonction.CouleurCandidat   := FrmConfig.ShapeCandidat.Brush.Color;
  DMFonction.CouleurJouable    := FrmConfig.ShapeJouable.Brush.Color;
  DMFonction.CouleurReference  := FrmConfig.ShapeReference.Brush.Color;
  DMFonction.CandidatsOnOff    := FrmConfig.CBCandidatsOnOff.Checked;
  DMFonction.ProtectionOnOff   := FrmConfig.CBProtectionOnOFF.Checked;

  If PageExtControl1.PageCount > 0 then
  begin
   LaFrame := PageExtControl1.ActivePage.FindComponent(PageExtControl1.ActivePage.Name);
   (LaFrame as TFramefille).MettreCouleurCandidat;
   (LaFrame as TFramefille).ToutRejouer;
  end;
 end;
 FrmConfig.Free; // liberation
end;


//*****************************************************************
// si le fichier n'a pas encore de nom
//*****************************************************************
procedure TFormMain.ActionEnregSousExecute(Sender: TObject);
Var
 LaFrame : TComponent;
 theSaveDialog       : TSaveDialog;
 RecentSaveFileAsDir : string;
 theFileName         : string;
 i                   : Integer;
begin
 theSaveDialog:=TSaveDialog.Create(nil); // construction d'une boite SAVE
 try
  // preparation de la boite
  theSaveDialog.Title:= DMFonction.GetTranslatedMessage('Enregistrer sous...', 23);
  theSaveDialog.DefaultExt:=EXT;
  RecentSaveFileAsDir:=DMFonction.LoadValueFromSettingsIniFile('RecentDirectories', 'RecentSaveFileAsDir', DMFonction.SettingsPath);
  if(Not(DirectoryExists(RecentSaveFileAsDir)))then
   RecentSaveFileAsDir:=DMFonction.SettingsPath;
  theSaveDialog.InitialDir:=RecentSaveFileAsDir;
  theSaveDialog.Filter:=DMFonction.GetTranslatedMessage('Fichiers XML', 24)+' (*.'+EXT+')|*.'+EXT;
  if(theSaveDialog.Execute)then
  begin
   // si ok
   theFileName:=theSaveDialog.Filename;
   if(FileExists(theFileName))then
    if(DMFonction.MessageLocalise('Le fichier [%s] existe dj.'+
      #13#10+ 'Voulez-vous  l''craser',ExtractFileName(theSaveDialog.Filename),'', 25, mtInformation,[mbYes, mbNo], 0)=mrNo)then
      Exit;
    LaFrame := PageExtControl1.ActivePage.FindComponent(PageExtControl1.ActivePage.Name);
   (LaFrame as TFramefille).CheminCourant := TheFileName;
   (LaFrame as TFramefille).AvoirNom := true;
   PageExtControl1.Pages[PageExtControl1.ActivePageIndex].Caption := Copy(ExtractFileName(TheFileName), 1, Length(ExtractFileName(TheFileName))-Length(ExtractFileExt(TheFileName)))+Space;
   (LaFrame as TFramefille).SaveToFile;
   //Ajout  la liste des fichiers recents
   RecentSaveFileAsDir:=ExtractFilePath(theSaveDialog.FileName);
   DMFonction.SaveValueInSettingsIniFile('RecentDirectories', 'RecentSaveFileAsDir', RecentSaveFileAsDir);
  end;
 finally
  theSaveDialog.Free;
 end;
end;


//*********************************
// appel de la Splash Form ( A propos sans Timer , le timer est actif uniquement au lancement)
//*********************************
procedure TFormMain.ActionAProposExecute(Sender: TObject);
var
 FormSplash : TFormSplash;
begin
 try
  FormSplash:=TFormSplash.Create(self);
  FormSplash.TimerSplash.Enabled := False;
  //DMFonction.TranslateForm(FormSplash);
  FormSplash.ShowModal;
 finally
  FormSplash.Free;
 End;
End;



//****************************************************************
// construction de la fentre principale
//****************************************************************
procedure TFormMain.FormCreate(Sender: TObject);
var
 theIni       : TMemIniFile;
 theStringList: TStringList;
 i            : Integer;
begin
 try
  theIni        :=TMemIniFile.Create(DMFonction.SettingsPath+'Settings.ini');
  theStringList :=TStringList.Create;

  //construction d'une liste des fichies recents
  theIni.ReadSectionValues('RecentFiles', theStringList);
  for i:=theStringList.Count-1 downto 0 do
   DMFonction.AddFileToRecentFilesList(Copy(theStringList[i], Pos('=', theStringList[i])+1, Length(theStringList[i])));

 finally
  Application.OnHint := ShowHint; // renvoi du onhint vers une routine personnalise
  CreerMenuLanguage; // construction dynamique du menu language
  DMFonction.SetLanguageCode(DMFonction.LanguageCode); //mettre le code language en place
  DMFonction.TranslateLanguage(Langues); // traduction de l'interface
  if(DMFonction.ShowTipsOnStartup)then // appel de tips (astuce) si c'est voulu
   ActionAstuceExecute(Self);
  theStringList.Free;
  theIni.Free;
 end;
end;

//************************************
// Les hints vers la barre d'tat
//************************************
procedure TFormMain.ShowHint(Sender : tObject);
begin
 StatusBar.Panels[0].Text := '  '+ GetLongHint(Application.Hint);
 StatusBar.Refresh;
end;
//************************************
// Les information diverses vers la barre d'tat
//************************************
procedure TFormMain.SetStatusCaption(s: string);
begin
  StatusBar.Panels[0].Text := '  '+ s;
  StatusBar.Refresh;
end;

//*************************************************
// gestion des menus pour les langues
//*************************************************
procedure TFormMain.CreerItemMenu(Code, Clair : String);
Var
 Option : TMenuItem;
begin
 Option := TMenuItem.Create(Langues);
 Option.name      := Code;
 Option.RadioItem := True;
 Langues. Add(option);
 Option.OnClick := LanguageChange;
 If (Code = DMFonction.LanguageCode) then
 begin
  Option.Checked := true;
  DMFonction.TranslateLanguage(Langues);
 end;
end;

procedure TFormMain.LanguageChange(Sender: TObject);
Begin
 DMFonction.SetLanguageCode((sender as TmenuItem).name);
 (sender as TmenuItem).Checked := True;
 DMFonction.TranslateLanguage(Langues);
End;


procedure TFormMain.CreerMenuLanguage;
Var
 LanguageList : TStringList;
 i            : Integer;
 TheIni       : Tinifile ;
Begin
 try
  LanguageList:=TStringList.Create;
  TheIni := TIniFile.Create(DMFonction.Chemin+'Translations.txt');
  theIni.ReadSectionValues('Languages', LanguageList);
  for i:=0 to LanguageList.Count-1 do
   if(LanguageList.ValueFromIndex[i]<>'xx')then
    CreerItemMenu(LanguageList.ValueFromIndex[i],LanguageList.Names[i]);
  finally
    theIni.Free;
    LanguageList.Free;
  end;
end;


//**********************************************************
// Appel de l'ecran TIPS avec l'astuce nouvelle
//**********************************************************
procedure TFormMain.ActionAstuceExecute(Sender: TObject);
Var
 TipText : String;
begin
 // appel de l'astuce
 TipText:=DMFonction.LoadTip;
 if(TipText<>'')then
 begin
  try
   TipsForm:=TTipsForm.Create(self);
   DMFonction.TranslateForm(TipsForm);
   TipsForm.TipMemo.Text:=TipText;
   TipsForm.caption := DMFonction.GetTranslatedMessage('Astuce Sudoku Trainer',20);
   TipsForm.DisableTipsOnStartupCBox.Checked := not DMFonction.ShowTipsOnStartup;
   TipsForm.Show;
  except
   TipsForm.Free;
  end;
 end;
end;


//**********************************************************
//  A l'affichage on confectionne un contexte propre
//**********************************************************
procedure TFormMain.FormShow(Sender: TObject);
begin
 Menu_BarreOutils.Checked :=  DMFonction.Toolbar_Visible; // la barre d'outils visible ou non
 ToolBarMain.Visible       := DMFonction.Toolbar_Visible;
 if(DMFonction.ReopenLastFile)and(DMFonction.GetRecentFileCount>0)then
  OpenFile(DMFonction.GetRecentFileName(0));
 MajAction;
end;




//*****************************************
// ON/OFF de la barre d'outils
//*****************************************
procedure TFormMain.Menu_BarreOutilsClick(Sender: TObject);
begin
  Menu_BarreOutils.Checked   := Not(Menu_BarreOutils.Checked);
  DMFonction.Toolbar_Visible := Menu_BarreOutils.Checked;
  ToolBarMain.Visible        := Menu_BarreOutils.Checked;
end;
//************************************************************
// Active/desactive les ActionsList e tmenu  en fonction du contexte
//************************************************************
procedure TFormMain.MajAction(Suppr : Boolean = False);
var
 Action : Boolean;
begin
 if Suppr then
  Action := PageExtControl1.PageCount > 1
 Else
  Action := PageExtControl1.PageCount > 0;

 ActionEnregistrer.Enabled       := Action;
 ActionEnregSous.Enabled         := Action;
 ActionImprime.Enabled           := Action;
 ActionDupliquer.Enabled         := Action;
 MenuCopier.Enabled              := Action;
 MenuColler.Enabled              := Action;
 ActionGrilleToJPG.enabled       := Action;

end;






//*****************************************
// Appel de la calculatrice Windows
//*****************************************

//***************************************
// Traitement de la recherche d'un
//  fichier de nouvelle version
//***************************************

procedure TFormMain.MenuNouvelleVersionClick(Sender: TObject);
var
 TheDownLoadURL : TDownLoadURL;
 cheminVersion,DateVersion,Info1,Info2,Info3, VersionLu : String;
 theIni: TMemIniFile;
begin
 Try
  cheminVersion := DMFonction.SettingsPath+'version.txt';
  If FileExists(cheminVersion) then
   DeleteFile(cheminVersion);
  TheDownLoadURL := TDownLoadURL.Create(self);
  TheDownLoadURL.Filename := cheminVersion;
  TheDownLoadURL.URL := 'http://p.fonten.free.fr/version.txt';
  TheDownLoadURL.Execute;
  If FileExists(cheminVersion) then
  begin
   theIni:=TMemIniFile.Create(cheminVersion);
   VersionLu    := theIni.ReadString('version','numero','');
   DateVersion  := theIni.ReadString('version','date','');
   Info1        := theIni.ReadString('info','info1','');
   Info2        := theIni.ReadString('info','info2','');
   Info3        := theIni.ReadString('info','info3','');
   If VersionLu = DMFonction.RenvoiVersion then
   begin // pas de nouvelle version
     ShowMessage('Votre version est  jour');  { TODO : traduire }
   End
   else
   begin // il existe une nouvelle version
     ShowMessage(info1+#10+#13+info2+#10+#13+info3);
   end;
  end;
  finally
   theIni.Free;
   TheDownLoadURL.free;
  end;
end;

//*****************************************
// Duplique  du Sudoku en cours dans
// une nouvelle fentre
//*****************************************
procedure TFormMain.ActionDupliquerExecute(Sender: TObject);
Var
  I : Integer;
  LaFrame : TComponent;
  NewTabs : TTabExtSheet;
  NewFrame : TFramefille;
begin
  LaFrame := PageExtControl1.ActivePage.FindComponent(PageExtControl1.ActivePage.Name);
  i := 0;
  For i := 0 to (LaFrame as TFramefille).PositionRecorder do
   RecorderTMP[i] := (LaFrame as TFramefille).Recorder[I];
  PositionRecorderTMP := i;
  DureePartieTMP := (LaFrame as TFramefille).DureePartie;
  //creation d'un nouvel onglet
 NewTabs := TTabExtSheet.Create(Self);
 with NewTabs do
 begin
  Name     := NomAleat(6);
  Caption  := NONAME+' '+DMFonction.GetNextNonameNumber+Space; //Initialise le nom
  Parent   := Self;
  PageExtControl := PageExtControl1;
  NewFrame := TFramefille.Create(NewTabs);
  NewFrame.Parent    := NewTabs;
  NewFrame.Align     := alClient;
  NewFrame.Name      := Name;
  NewFrame.CheminCourant := '';
  NewFrame.AvoirNom  := False;
  NewFrame.CreerPlateau;
 end;

  // le chargement du recorderTMP se fait dans la fentre fille au chargement
end;


//*****************************************
// Copie le Sudoku dans le presse papier de Windows
//*****************************************
procedure TFormMain.EditCopierExecute(Sender: TObject);
Var
 LaFrame : TComponent;
begin
 LaFrame := PageExtControl1.ActivePage.FindComponent(PageExtControl1.ActivePage.Name);
    (LaFrame as TFramefille).GrilleToPP;
end;

//*****************************************
// Rcupere le sudoku du PP de Windows
// et le pose dans la grille(vide) courante
//*****************************************
procedure TFormMain.EditCollerExecute(Sender: TObject);
Var
 LaFrame : TComponent;
begin
 LaFrame := PageExtControl1.ActivePage.FindComponent(PageExtControl1.ActivePage.Name);
    (LaFrame as TFramefille).PPToGrille;
end;

//*****************************************
// Generer un fichier JPEG sur le dique depuis la grille courante
//*****************************************
procedure TFormMain.ActionGrilleToJPGExecute(Sender: TObject);
var
  jp: TJPEGImage;
  theFileName: String;
begin
 IF SaveDialogBMP.Execute then
 Begin
  theFileName:=SaveDialogBMP.Filename;
  if(FileExists(theFileName))then    { TODO : traduire }
   if MessageDlg('Le fichier '+ExtractFileName(theFileName)+' existe dj.'+ #13#10+ 'Voulez-vous  l''craser ?',mtInformation,[mbYes, mbNo], 0)= mrNo then
    Exit;
  update;
  ImageJPG.Canvas.CopyRect(Rect(0,0,445,465), PageExtControl1.canvas,Rect(20,45,465,520));
  jp := TJPEGImage.Create;
  try
    with jp do
    begin
      Assign(ImageJPG.Picture.Bitmap);
      SaveToFile(SaveDialogBMP.FileName);
    end;
  finally
    jp.Free;
  end;
 end;
end;

function TFormMain.NomAleat(Lg : Integer): String;
var
 I : Integer;
begin
 result :='';
 for I := 0 to lg - 1 do
  Result := Result + Chr(Aleatoire(65,90));
end;

//************************************************//
// renvoi un nombre aleatoire compris entre
// Num1 et Num2     exemple : Aleatoire(65,91)
//************************************************//
function TFormMain.Aleatoire(Num1,Num2:integer):integer;
var
 Diff: integer;
begin
 inc(Num2);
 Diff:=Num2-Num1;
 Result := Random(Diff)+ Num1;
end;


end.
